// Sega produlzhavame s nai hitoviq kiuchek ot djodji bend specialno za vsichki romi
// Kuicheka konya vihyr 2012
// Novata modifikaciq
// Aide Chochko
// Aide Vihyre
// Vlez
// Vlez Vihyre

#include <unordered_map>
#include <algorithm>
#include <iostream>
#include <iomanip>
#include <numeric>
#include <vector>
#include <queue>
#include <map>

typedef long long llong;
const llong MAXN = 100000 + 10;
const llong INF  = 1e9;

llong n, q, c, r;
llong perm[MAXN];
llong sorted[MAXN];
std::pair <llong,llong> AA[MAXN];
llong a[MAXN];
llong currAns;

llong curr;
void move(int from, int to)
{
    if (from == to) return;
    if (from > to)
    {
        for (int i = from ; i > to ; --i)
        {
            curr += a[i] + a[i-1];
            std::swap(a[i], a[i-1]);
        }
    } else
    {
        for (int i = from ; i < to ; ++i)
        {
            curr += a[i] + a[i+1];
            std::swap(a[i], a[i+1]);
        }
    }
}

inline void moveInside(llong pos)
{
    for (llong i = pos ; i > r ; --i)
    {
        currAns += AA[i].second + AA[i - 1].second;
        std::swap(AA[i], AA[i-1]);
    }
}

inline void moveOutside(llong pos)
{
    for (llong i = pos ; i <= r ; ++i)
    {
        currAns += AA[i].second + AA[i + 1].second;
        std::swap(AA[i], AA[i+1]);
    }
}

llong solveOne()
{
    if (r == n)
    {
        llong ans = 0;
        for (llong i = 1 ; i <= n ; ++i)
        {
            ans += AA[i].second * c;
        }

        return ans;
    }

    llong ans = 0;
    for (llong i = 1 ; i <= r ; ++i) ans += c * AA[i].second;
    std::iota(perm + 1, perm + 1 + n, 1);
    do
    {
        std::sort(AA + 1, AA + 1 + n);
        currAns = 0;

        for (llong idx = 1 ; idx <= n ; ++idx)
        {
            llong currPos = perm[idx];
            for (llong i = 1 ; i <= n ; ++i)
            {
                if (AA[i].first == currPos)
                {
                    if (i <= r) moveOutside(i);
                    else moveInside(i);
                    break;
                }
            }

            llong addToAns = 0;
            for (llong i = 1 ; i <= r ; ++i)
            {
                addToAns += c * AA[i].second;
            }

            ans = std::min(ans, addToAns + currAns);
         }
    } while(std::next_permutation(perm + 1, perm + 1 + n));
    return ans;
}

llong solveTwo()
{
    std::iota(perm + 1, perm + 1 + n, 1);
    std::iota(sorted + 1, sorted + 1 + n, 1);
    std::sort(sorted + 1, sorted + 1 + n, [&](int x, int y)
    {
        return AA[x].second < AA[y].second;
    });

    llong ans = 0;
    for (int i = 1 ; i <= r ; ++i)
    {
        ans += c * AA[i].second;
    }

    do
    {
        std::sort(AA + 1, AA + 1 + n);
        for (int i = 1 ; i <= n ; ++i) a[i] = AA[i].second;
        
        curr = 0;
        for (int i = 1 ; i <= n ; ++i)
        {
            int pos = 0;
            for (int j = 1 ; j <= n ; ++j)
            {
                if (a[j] == AA[sorted[i]].second)
                {
                    pos = j;
                    break;
                }
            }

            move(pos, perm[i]);
        }

        for (int i = 1 ; i <= r ; ++i)
        {
            curr += a[i] * c;
        }

        ans = std::min(ans, curr);
    } while(std::next_permutation(perm + 1, perm + 1 + n));
    return ans;
}

void solve()
{
    std::cout << std::min(solveOne(), solveTwo()) << '\n';
}

void read()
{
    std::cin >> n >> q >> c;
    for (llong i = 1 ; i <= n ; ++i)
    {
        AA[i].first = i;
        std::cin >> AA[i].second;
    }

    std::cin >> r;
}

void fastIOI()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIOI();
    read();
    solve();

    return 0;
}