// Sega produlzhavame s nai hitoviq kiuchek ot djodji bend specialno za vsichki romi
// Kuicheka konya vihyr 2012
// Novata modifikaciq
// Aide Chochko
// Aide Vihyre
// Vlez
// Vlez Vihyre

#include <unordered_map>
#include <algorithm>
#include <iostream>
#include <iomanip>
#include <numeric>
#include <vector>
#include <queue>
#include <map>

typedef long long llong;
const int INF  = 1e9;
const int MAXturns = 4500;

struct Key
{
	int l, r, backspace, turns;
};

double p;
int n, l, r;
std::unordered_map <llong,double> dp;
inline llong getKey(Key curr)
{
	return curr.l + curr.r * MAXturns + 1LL * curr.backspace * MAXturns * MAXturns + 1LL * curr.turns * 3 * MAXturns * MAXturns; 
}

double f(int ptrL, int ptrR, int backspace, int turns)
{
	if (ptrL > n + 1 || ptrR > n + 1) return INF;
	if (turns > MAXturns) return 0;
	if (ptrL == n && ptrR == n) return 0.0;
	if (dp.count(getKey({ptrL, ptrR, backspace, turns}))) return dp[getKey({ptrL, ptrR, backspace, turns})];

	if (backspace == 0)
	{
		if (ptrL == ptrR)
		{
			dp[getKey({ptrL, ptrR, backspace, turns})] = 1.0 + f(ptrL + 1, ptrR, 0, turns + 1) * p + f(ptrL, ptrR + 1, 0, turns + 1) * (1 - p);
		} else
		{
			dp[getKey({ptrL, ptrR, backspace, turns})] = 1.0 + std::min(f(ptrL + 1, ptrR, 0, turns + 1) * p + f(ptrL, ptrR, 2, turns + 1) * (1.0 - p), 
															  f(ptrL, ptrR, 1, turns + 1) * p + f(ptrL, ptrR + 1, 0, turns + 1) * (1.0 - p));
		}
	} else if (backspace == 1)
	{
		dp[getKey({ptrL, ptrR, backspace, turns})] = 1.0 + f(ptrL, ptrR, 0, turns + 1) * p + f(ptrL, std::max(0, ptrR - 1), 1, turns + 1) * (1.0 - p);
	} else
	{
		dp[getKey({ptrL, ptrR, backspace, turns})] = 1.0 + f(std::max(0, ptrL - 1), ptrR, 2, turns + 1) * p + f(ptrL, ptrR, 0, turns + 1) * (1.0 - p);
	}

	return dp[getKey({ptrL, ptrR, backspace, turns})];
}

void solve()
{
	std::cout << std::fixed << std::setprecision(12) << f(l, r, 0, 0) << '\n';
}

void read()
{
	std::cin >> p >> n >> l >> r;
}

void fastIOI()
{
	std::ios_base :: sync_with_stdio(0);
	std::cout.tie(nullptr);
	std::cin.tie(nullptr);
}

int main()
{
	fastIOI();
	read();
	solve();

	return 0;
}