#include<bits/stdc++.h>
#define endl "\n"
#define mkstate(a, b, c, d) {{a, b}, {c, d}}
#define state pair< pair<int, int>, pair<int, int> >
#define cl first.first
#define cr first.second
#define wl second.first
#define wr second.second
using namespace std;

using ldouble = long double;

const ldouble thr = 0.001;
map<state, ldouble> precalc;
ldouble p, lp, rp;
int n, l, r;

bool correct(const state& s)
{
    return s.cl == n && s.cr == n && s.wl == 0 && s.wr == 0;
}
bool no_wrong(const state& s)
{
    return s.wl == 0 && s.wr == 0;
}

ldouble solve(state current, int steps, ldouble poss)
{
    if(correct(current)) return poss * steps;
    if(poss < thr) return 0;
    ldouble val = 0;
    if(no_wrong(current))
    {
        // wanted == inserted
        val += solve(mkstate(current.cl+1, current.cr, 0, 0), steps+1, poss*lp);
        val += solve(mkstate(current.cl, current.cr+1, 0, 0), steps+1, poss*rp);
        if(current.cl != current.cr)
        {
            // wanted != inserted
            val += solve(mkstate(current.cl, current.cr, 1, 0), steps+1, poss*lp);
            val += solve(mkstate(current.cl, current.cr, 0, 1), steps+1, poss*rp);
        }
    }
    else
    {
        // try to remove wrong:
        if(current.wl == 1) // wrong is on the left
        {
            // correctly deleted:
            val += solve(mkstate(current.cl, current.cr, 0, 0), steps+1, poss*lp); // - deleted from left
            // wrongly deleted:
            val += solve(mkstate(current.cl, max(current.cr-1, 0), 1, 0), steps+1, poss * rp); // - deleted from right
        }
        else if(current.wr == 1) // wrong is on the right
        {
            // correctly deleted:
            val += solve(mkstate(current.cl, current.cr, 0, 0), steps+1, poss*rp); // - deleted from right
            // wrongly deleted:
            val += solve(mkstate(max(current.cl-1, 0), current.cr, 0, 1), steps+1, poss * lp); // - deleted from left
        }
    }
    return val;
}

int main()
{
    cin >> p >> n >> l >> r;
    lp = p; rp = 1-p;
    cout << std::setprecision(12) << solve(mkstate(l, r, 0, 0), 0, 1) << endl;
    return 0;
}
