#include<bits/stdc++.h>
#define endl "\n"
#define mkstate(a, b, c, d) {{a, b}, {c, d}}
#define state pair< pair<int, int>, pair<int, int> >
#define cl first.first
#define cr first.second
#define wl second.first
#define wr second.second
using namespace std;

using ldouble = long double;

const ldouble thr = 0.001;
map<state, ldouble> precalc;
map<state, bool> proc;
map<state, int> cycles;
ldouble p, lp, rp;
int n, l, r;

ostream& operator<<(ostream& str, state s)
{
    str << s.cl << " " << s.cr << " " << s.wl << " " << s.wr;
    return str;
}

bool correct(const state& s)
{
    return s.cl == n && s.cr == n && s.wl == 0 && s.wr == 0;
}
bool no_wrong(const state& s)
{
    return s.wl == 0 && s.wr == 0;
}

int calls = 0;

ldouble solve(const state& current)
{
    if(correct(current)) return 0;
    if(proc[current]) return -1;

    ldouble pre = precalc[current];
    if(pre != 0) return pre;

    proc[current] = true;

    ldouble val = 0;
    state next;

    if(no_wrong(current))
    {
        //bool eq = current.cl == current.cr;
        if(current.cl != n)
        {
            next = mkstate(current.cl+1, current.cr, 0, 0);
            /* if(!proc[next]) */ val += (solve(next) + 1) * lp;

            next = mkstate(current.cl, current.cr, 0, 1);
            /* if(!proc[next]) */ val += (solve(next) + 1) * rp;
        }
        if(current.cr != n)
        {
            next = mkstate(current.cl, current.cr+1, 0, 0);
            /* if(!proc[next]) */ val += (solve(next) + 1) * rp;

            next = mkstate(current.cl, current.cr, 1, 0);
            /* if(!proc[next]) */ val += (solve(next) + 1) * lp;
        }
    }
    else
    {
        if(current.wl == 1) // wrong is on the left
        {
            next = mkstate(current.cl, current.cr, 0, 0);
            cycles[next]++;

            next = mkstate(current.cl, max(current.cr-1, 0), 1, 0);
            cycles[next]++;
        }
        else if(current.wr == 1) // wrong is on the right
        {
            next = mkstate(current.cl, current.cr, 0, 0);
            cycles[next]++;

            next = mkstate(max(current.cl-1, 0), current.cr, 0, 1);
            cycles[next]++;
        }
    }

    proc[current] = false;

    precalc[current] = val * cycles[current];
    return precalc[current];
}

int main()
{
    // 0.5 1 0 0
    cin >> p >> n >> l >> r;
    lp = p; rp = 1-p;
    cout << std::setprecision(12) << solve(mkstate(l, r, 0, 0)) << endl;
    return 0;
}
