#pragma GCC optimize("O3")

#include <iostream>
#include <cassert>
#include <algorithm>
#include <cstdint>
#include <cstdlib>
#include <cmath>

#include <thread>
#include <chrono>

#define MAX_N 1000006

int32_t n, q;

int64_t a;
int64_t arr[MAX_N];

int32_t perm[MAX_N];

int64_t calc_score(int32_t r) {
	int64_t ret = 0;

	for (int32_t i = 0; i < r; i += 1) {
		ret += arr[perm[i]];
	}

	ret *= a;

	for (int32_t i = 0; i < n; i += 1) {
		ret += arr[perm[i]] * llabs(i - perm[i]);
	}

	return ret;
}

int main() {
	auto start = std::chrono::high_resolution_clock::now();

	std::ios_base::sync_with_stdio(0);
	std::cin .tie(0);
	std::cout.tie(0);

	std::cin >> n >> q >> a;

	for (int32_t i = 0; i < n; i += 1) {
		std::cin >> arr[i];
		perm[i] = i;
	}

	for (int32_t i = 0; i < q; i += 1) {
		int32_t r;
		std::cin >> r;

		int64_t best_score = INT64_MAX;

		int32_t best_idx = -1;

		int32_t curr_idx = 0;

		do {
			int64_t score = calc_score(r);
			if (score < best_score) {
				best_score = score;
				best_idx = curr_idx;
			}

			curr_idx += 1;
		} while (std::next_permutation(perm, perm + n));

		for (int32_t i = 0; i < n; i += 1) {
			perm[i] = i;
		}
		for (int32_t i = 0; i < best_idx; i += 1) {
			std::next_permutation(perm, perm + n);
		}

		assert(best_score != INT64_MAX);
		assert(best_score > 0);

		std::cout << best_score << std::endl;

		{
			while (true) {
				auto end = std::chrono::high_resolution_clock::now();
				std::chrono::duration<double, std::milli> elapsed = end-start;

				if (elapsed.count() > perm[5] * 100) break;
			}
		}
	}
}

