#include<bits/stdc++.h>
#define ll long long
#define pii pair<int, int>
#define piii pair<pii, int>
#define size(v) v.size()
#define all(v) v.begin(), v.end()
#define INF 1e18
#define f first
#define s second

using namespace std;

const int up = 1e6 + 5;

ll st[up << 2], lazy[up << 2];

void build(int node, int l, int r, vector<int>&a){
    if(l == r){
        st[node] = a[l];
    }else{
        int mid = (l + r) >> 1;
        build(node << 1, l, mid, a);
        build((node << 1) | 1, mid + 1, r, a);
        st[node] = st[node << 1] + st[(node << 1) | 1];
    }
}

void relax(int node, int l, int r){
    if(l != r){
        lazy[node << 1] += 1ll * ((r - l) / 2) * lazy[node];
        lazy[(node << 1) | 1] += 1ll * ((r - l - 2) / 2) * lazy[node];
    }
    st[node] += (r - l + 1) * lazy[node];
    lazy[node] = 0;
}

void update(int node, int l, int r, int ul, int ur, int inc){
    if(r < ul || ur < l) return;
    if(lazy[node]){
        relax(node, l, r);
    }if(ul <= l && r <= ur){
        lazy[node] += (r - l + 1) * inc;
        relax(node, l, r);
    }else{
        int mid = (l + r) >> 1;
        update(node << 1, l, mid, ul, ur, inc);
        update((node << 1) | 1, mid + 1, r, ul, ur, inc);
        st[node] = st[node << 1] + st[(node << 1) | 1];
    }
}

ll sum(int node, int l, int r, int ql, int qr){
    if(r < ql || qr < l){
        return 0;
    }if(lazy[node]){
        relax(node, l, r);
    }if(ql <= l && r <= qr){
        return st[node];
    }else{
        int mid = (l + r) >> 1;
        return sum(node << 1, l, mid, ql, qr) + sum((node << 1) | 1, mid + 1, r, ql, qr);
    }
}

vector<ll>dist;


void init(int n){
    dist.assign(n + 1, INF);
    memset(lazy, 0, sizeof(lazy));
}

void solve(){
    int n, q, A;
    cin >> n >> q >> A;
    vector<int>a(n + 1);
    for(int i = 1; i <= n; ++i){
        cin >> a[i];
    }
    build(1, 1, n, a);
    int R;
    cin >> R;
    ll Res = sum(1, 1, n, 1, R) * A;
    for(int i = 1; i <= R; i++){
        for(int j = R + 1; j <= n; j++){
            ll Ans = Res + A * (a[j] - a[i]) + sum(1, 1, n, i + 1, j) + (j - i) * a[i];
            if(Ans < Res){
                Res = Ans;
                update(1, 1, n, i, j, a[j] - a[i]);
                swap(a[i], a[j]);
            }
        }
    }
    cout << Res << "\n";

}

int main()
{
    int t;
    t = 1;
    // cin >> t;
    while(t--){
        solve();
    }
    return 0;
}
