#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <numeric>
using namespace std;

typedef long long ll;

const ll INF = 1e9;
const ll LLINF = 1e18;
const ll MOD = 1e9 + 7;

ll gcd(ll a, ll b) {
    if (b == 0)
        return a;
    return gcd(b, a % b);
}

int n, q;
ll a, r;
ll res = LLINF;
vector<ll> cur;
vector<ll> pref;
void gen(int left, ll curRes) {
    res = min(res, curRes + pref[r] * a);
    if (left == 0)
        return;
    for (int i = 0; i < cur.size() - 1; ++i) {
        swap(cur[i], cur[i + 1]);
        pref[i + 1] += cur[i] - cur[i + 1];
        gen(left - 1, curRes + cur[i] + cur[i + 1]);
        swap(cur[i], cur[i + 1]);
        pref[i + 1] += cur[i] - cur[i + 1];
    }
}

void pickGen(int left, int index, ll curRes) {
    if (left == 0) {
        res = min(res, curRes);
        return;
    }
    for (int i = index; i < n; ++i) {
        ll delta = cur[i] * a;
        for (int j = i - 1; j >= index; --j) {
            delta += cur[j] + cur[j + 1];
            swap(cur[j], cur[j + 1]);
        }
        pickGen(left - 1, index + 1, curRes + delta);
        for (int j = index; j < i; ++j)
            swap(cur[j], cur[j + 1]);
    }
}

void solve() {
    cin >> n >> q >> a;
    cur.resize(n);
    for (int i = 0; i < n; ++i)
        cin >> cur[i];
    pref.resize(n + 1, 0);
    for (int i = 1; i < n; ++i)
        pref[i] = pref[i - 1] + cur[i - 1];
    while (q--) {
        cin >> r;
        res = LLINF;
        pickGen(r, 0, 0);
        cout << res << "\n";
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    // freopen("input.txt", "r", stdin);
    // freopen("output.txt", "w", stdout);

    solve();
}
