#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <numeric>
#include <cassert>
#include <random>
using namespace std;

typedef long long ll;

const ll INF = 1e9;
const ll LLINF = 2e18;
const ll MOD = 1e9 + 7;
const ll SZ = 5e3;

mt19937 rnd(1000 - 7);

ll gcd(ll a, ll b) {
    if (b == 0)
        return a;
    return gcd(b, a % b);
}

int n, q;
ll a, r;
ll res = LLINF;
vector<ll> cur;
void pickGen(int left, int index, ll curRes) {
    if (left == 0) {
        res = min(res, curRes);
        return;
    }
    for (int i = index; i < n; ++i) {
        ll delta = cur[i] * a;
        for (int j = i - 1; j >= index; --j) {
            delta += cur[j] + cur[j + 1];
            swap(cur[j], cur[j + 1]);
        }
        pickGen(left - 1, index + 1, curRes + delta);
        for (int j = index; j < i; ++j)
            swap(cur[j], cur[j + 1]);
    }
}

void stupidSolve() {
    cin >> n >> q >> a;
    cur.resize(n);
    for (int i = 0; i < n; ++i)
        cin >> cur[i];
    while (q--) {
        cin >> r;
        res = LLINF;
        pickGen(r, 0, 0);
        cout << res << "\n";
    }
}

vector<ll> v, pref;
vector<ll> dp[SZ], cost[SZ], prevK[SZ];

void dpSolve() {
    assert(a > 0 && a <= 1e6);
    v.assign(n, 0);
    pref.assign(n + 1, 0);
    for (int i = 0; i < n; ++i)
        cin >> v[i];
    // for (int i = 0; i < n; ++i)
    //     v[i] = rnd() % (ll)(1e6);
    for (int i = 1; i <= n; ++i)
        pref[i] = pref[i - 1] + v[i - 1];
    for (int i = 0; i < SZ; ++i) {
        dp[i] = vector<ll>(n + 1, LLINF);
        cost[i] = vector<ll>(n + 1, LLINF);
        prevK[i] = vector<ll>(n + 1, -1);
    }

    dp[0][0] = 0;
    dp[0][1] = v[0] * a;
    cost[0][0] = 0;
    cost[0][1] = 0;
    for (ll i = 1; i < n; ++i) {
        dp[i][0] = 0;
        dp[i][1] = pref[i] + v[i] * (a + i);
        cost[i][0] = pref[i + 1];
        cost[i][1] = pref[i];
        for (ll j = 2; j <= i + 1; ++j) {
            ll k = i - 1;
            ll pk = prevK[i - 1][j];
            if (pk != -1 && dp[pk][j - 1] + cost[pk][j - 1] - pref[pk + 1] < dp[k][j - 1] + cost[k][j - 1] - pref[k + 1]) {
                k = pk;
            }
            assert(dp[k][j - 1] < LLINF && dp[k][j - 1] >= 0);
            dp[i][j] = dp[k][j - 1] + cost[k][j - 1] + pref[i] - pref[k + 1] + v[i] * (a + i - j + 1ll);
            assert(dp[i][j] < LLINF && dp[i][j] >= 0);
            cost[i][j] = cost[k][j - 1] + pref[i] - pref[k + 1];
            prevK[i][j] = k;
        }
    }
    while (q--) {
        cin >> r;
        ll minRes = 6e18;
        for (int i = 0; i < n; ++i)
            minRes = min(minRes, dp[i][r]);
        cout << minRes << "\n";
        // cur = v;
        // res = LLINF;
        // pickGen(r, 0, 0);
        // cout << minRes << " " << res << "\n";
        // assert(minRes == res);
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    // freopen("input.txt", "r", stdin);
    // freopen("output.txt", "w", stdout);
    cin >> n >> q >> a;
    dpSolve();
    // stupidSolve();
}
