#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <numeric>
#include <cassert>
using namespace std;

typedef long long ll;

const ll INF = 1e9;
const ll LLINF = 2e18;
const ll MOD = 1e9 + 7;

ll gcd(ll a, ll b) {
    if (b == 0)
        return a;
    return gcd(b, a % b);
}

int n, k;
vector<pair<ll, ll>> pass;
vector<ll> lifts;
ll res = LLINF;
void gen(int i, ll cur) {
    if (i == n) {
        res = min(res, cur);
        return;
    }
    for (int j = 0; j < k; ++j) {
        ll plift = lifts[j];
        ll delta = 0;
        if (plift != -1)
            delta = abs(plift - pass[i].first);
        lifts[j] = pass[i].second;
        gen(i + 1, cur + delta);
        lifts[j] = plift;
    }
}

void solve() {
    cin >> n >> k;
    pass.resize(n);
    lifts.assign(k, -1);

    for (int i = 0; i < n; ++i) {
        ll l, r;
        cin >> l >> r;
        pass[i] = {l, r};
    }

    gen(0, 0);
    cout << res << "\n";
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    // freopen("input.txt", "r", stdin);
    // freopen("output.txt", "w", stdout);

    solve();
}
