#include <bits/stdc++.h>
#ifdef LOCAL
#else
#define debug(...)
#endif
#define int long long
using namespace std;

int inverses(const vector<int> &t, const vector<int> &v) {
    int n = (int)t.size();
    vector<int> fcnt(n + 1);
    vector<int> fsum(n + 1);
    auto add = [&](int i) {
        int val = v[i];
        i = n - i;
        for (; i <= n; i += i & -i) {
            fcnt[i] += 1;
            fsum[i] += val;
        }
    };
    auto get = [&](int i) {
        i = n - i;
        int cnt = 0;
        int sum = 0;
        for (; i > 0; i -= i & -i) {
            cnt += fcnt[i];
            sum += fsum[i];
        }
        return make_pair(cnt, sum);
    };
    int ans = 0;
    for (int i : t) {
        auto [cnt, sum] = get(i);
        ans += v[i] * cnt + sum;
        add(i);
    }
    return ans;
}

void solve(int n, vector<int>& v, int A, int r) {
    vector<int> t(n);
    iota(t.begin(), t.end(), 0);
    int ans = INT64_MAX;
    do {
        int res = 0;
        for (int i = 0; i < r; i++) {
            res += v[t[i]] * A;
        }
        res += inverses(t, v);
        ans = min(ans, res);
    } while (next_permutation(t.begin(), t.end()));
    cout << ans << "\n";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, q, A;
    cin >> n >> q >> A;
    vector<int> v(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i];
    }
    while (q--) {
        int r; cin >> r;
        solve(n, v, A, r);
    }
    return 0;
}
