#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <set>
#include <algorithm>


using namespace std;

typedef long long ll;

struct seg_tree {
	int n;
	vector<ll> t;
	seg_tree(int n, vector<int>& a) : n(n) {
		t.resize(4 * n);
		build(0, 0, n, a);
	}
	void build(int v, int l, int r, vector<int>& a) {
		if (l + 1 == r) {
			t[v] = a[l];
			return;
		}
		int m = (l + r) / 2;
		build(2 * v + 1, l, m, a);
		build(2 * v + 2, m, r, a);
		t[v] = t[2 * v + 1] + t[2 * v + 2];
	}
	void set(int v, int l, int r, int i, int s) {
		if (l + 1 == r) {
			t[v] = s;
			return;
		}
		int m = (l + r) / 2;
		if (i < m) {
			set(2 * v + 1, l, m, i, s);
		}
		else {
			set(2 * v + 2, m, r, i, s);
		}
		t[v] = t[2 * v + 1] + t[2 * v + 2];
	}

	void set(int i, int s) {
		set(0, 0, n, i, s);
	}

	ll get_sum(int v, int l, int r, int ql, int qr) {
		if (ql >= r || qr <= l) {
			return 0;
		}
		if (ql <= l && r <= qr) {
			return t[v];
		}
		int m = (l + r) / 2;
		ll a = get_sum(2 * v + 1, l, m, ql, qr);
		ll b = get_sum(2 * v + 2, m, r, ql, qr);
		return a + b;
	}
	ll get_sum(int ql, int qr) {
		return get_sum(0, 0, n, ql, qr);
	}
};

int n, q, a;
vector<int> v;

ll go_to_out(int i, int r, seg_tree& st) {
	return st.get_sum(i + 1, r) + (r - i - 1) * v[i];
}

ll go_to_in(int i, int r, seg_tree& st) {
	return st.get_sum(r, i) + (i - r) * v[i];
}

void solve(int r) {
	seg_tree st(n, v);
	ll cnt = 0;
	for (int i = r; i < n; ++i) {
		for (int j = 0; j < r; ++j) {
			ll out = go_to_out(j, r, st);
			ll in = go_to_in(i, r, st);
			if (out + in + (v[i] + v[j]) + (st.get_sum(0, r) + v[i] - v[j]) * a < st.get_sum(0, r) * a) {
				cnt += out + in + (v[i] + v[j]);
				st.set(j, v[r - 1]);
				st.set(i, v[r]);
				st.set(r - 1, v[i]);
				st.set(r, v[j]);
				swap(v[j], v[r - 1]);
				swap(v[i], v[r]);
				swap(v[r - 1], v[r]);
			}
		}
	}
	cout << st.get_sum(0, r) * a + cnt << "\n";
}


int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	cin >> n >> q >> a;
	v.resize(n);
	for (int& i : v)
		cin >> i;
	for (int i = 0; i < q; ++i) {
		int r;
		cin >> r;
		solve(r);
	}
}