#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;
#define int long long
const int INF = 1e13;
const int IINF = 1e18;

int n, cur_cost = 0, len = 0;
vector <pair <int, int>> a;
map <pair <int, int>, int> ex;
vector <int> in, out, pt, taken;

inline int get_edge(int i, int j) {
    return abs(a[i].second - a[j].first);
}

inline int get_left(int i) {
    return 2 + i;
}

inline int get_right(int i) {
    return n + 2 + i;
}

bool push_flow() {
    vector <int> d(len, IINF), used(len), pr(len, -1);
    d[0] = 0;

    auto relax = [&](int i, int x, int p) {
        if (d[i] > x) {
            d[i] = x;
            pr[i] = p;
        }
    };

    while (true) {
        int pos = -1;
        for (int i = 0; i < len; ++i) {
            if (!used[i] && (pos == -1 || d[pos] > d[i])) {
                pos = i;
            }
        }
        if (pos == -1) break;
        used[pos] = 1;
        if (pos == 1) break;
        if (pos == 0) {
            for (int i = 0; i < n; ++i) {
                if (taken[i]) continue;
                d[get_left(i)] = -pt[get_left(i)];
                pr[get_left(i)] = 0;
            }
            continue;
        }
        if (pos <= n + 1) {
            int i = pos - 2;
            if (in[pos] == -1) {
                relax(get_right(i), d[pos] - INF + pt[pos] - pt[get_right(i)], pos);
            } else {
                if (in[pos] != 0) relax(in[pos], d[pos] + pt[pos] - pt[in[pos]] - get_edge(in[pos] - (n + 2), i), pos);
            }
        } else {
            int i = pos - (n + 2);
            if (in[pos] == -1) {
                for (int j = i + 1; j < n; ++j) {
                    relax(get_left(j), d[pos] + pt[pos] - pt[get_left(j)] + get_edge(i, j), pos);
                }
                relax(1, d[pos] + pt[pos] - pt[1], pos);
            } else {
                for (int j = i + 1; j < n; ++j) {
                    if (j == get_left(j) == out[pos]) continue;
                    relax(get_left(j), d[pos] + pt[pos] - pt[get_left(j)] + get_edge(i, j), pos);
                }
                relax(1, d[pos] + pt[pos] - pt[1], pos);
                relax(in[pos], d[pos] + pt[pos] - pt[in[pos]] + INF, pos);
            }
        }
    }
    if (used[1] == 0) return false;
    for (int i = 0; i < len; ++i) {
        pt[i] = pt[i] + d[i];
    }
    cur_cost += pt[1];
    int cur = 1;
    in.assign(len, -1);
    out.assign(len, -1);
    while (cur > 0) {
        int p = pr[cur];
        ex[make_pair(cur, p)] ^= 1;
        ex[make_pair(p, cur)] ^= 1;
        cur = p;
    }
    for (auto i : ex) {
        if (i.second == 1) {
            int u = i.first.first;
            int v = i.first.second;
            if (u > v) continue;
            if (u == 0) {
                in[v] = 0;
            } else if (u == 1) {
                out[v] = 1;
            } else {
                if (u + n == v) {
                    out[u] = v;
                    in[v] = u;
                } else {
                    out[v] = u;
                    in[u] = v;
                }
            }
        }
    }
    return true;
}

inline void solve() {
    int k;
    cin >> n >> k;
    len = 2 * n + 2;
    a.resize(n);
    in.resize(len, -1);
    out.resize(len, -1);
    pt.resize(len);
    taken.resize(n);
    for (int i = 0; i < n; ++i) cin >> a[i].first >> a[i].second;
    pt[0] = pt[get_left(0)];
    pt[get_right(0)] = -INF;
    for (int i = 1; i < n; ++i) {
        pt[get_left(i)] = pt[get_right(i - 1)] + get_edge(i - 1, i);
        pt[get_right(i)] = pt[get_left(i)] - INF;
    }
    pt[1] = pt[get_right(n - 1)];
    int ans = INF;
    while (k) {
        if (!push_flow()) break;
        ans = min(ans, cur_cost);
        k--;
    }
    cout << ans + n * INF;
}

signed main() {
    if (1) {
        ios_base::sync_with_stdio(false);
        cin.tie(nullptr);
        cout.tie(nullptr);
    }
    if (1) {
        solve();
    }
}

/*
3 2
5 20
8 100
2 80
 */