#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int N = 5e4 + 7;
const int B = 289;
const int K = 289;
const ll INF = 4e18;

struct ConvexHull {
	struct Line {
		ll k, b;
	};

	bool bad(const Line &l1, const Line &l2, const Line &l3) {
		return (l3.b - l1.b) * (l2.k - l3.k) <= (l3.b - l2.b) * (l1.k - l3.k);
	}

	bool good(const Line &l1, const Line &l2, ll x) {
		return (l2.b - l1.b) <= x * (l1.k - l2.k);
	}

	vector<Line> st;
	int ptr;

	void addline(ll k, ll b) {
		Line l = {k, b};
		if (!st.empty() && st.back().k == k) {
			if (st.back().b <= b) {
				return;
			}
			st.pop_back();
		}
		while (st.size() >= 2 && bad(st[st.size() - 2], st.back(), l)) {
			st.pop_back();
		}
		st.push_back(l);
	}

	ll getmin(ll x) {
		while (ptr + 1 < (int)st.size() && good(st[ptr], st[ptr + 1], x)) {
			++ptr;
		}
		return st.empty() ? INF : st[ptr].k * x + st[ptr].b; 
	}

	void clear() {
		st.clear();
		ptr = 0;
	}
};

int n, q;
ll A;
ll v[N];
ll a[N];
ll kek[N];
ll ans[N];
int nb;
int lb[K], rb[K];
vector<int> ord[K];
ConvexHull chmin[K], chmax[K];
bool fmn[N], fmx[N];

void buildmin(int id) {
	chmin[id] = {};
	for (int i : ord[id]) {
		if (fmn[i]) {
			chmin[id].addline(-v[i], a[i]);
		}
	}
}

void buildmax(int id) {
	chmax[id] = {};
	for (int i : ord[id]) {
		if (fmx[i]) {
			chmax[id].addline(v[i], -a[i]);
		}
	}
}

ll getmin(int id, ll x) {
	return chmin[id].getmin(x);
}

ll getmax(int id, ll x) {
	return -chmax[id].getmin(x);
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cin >> n >> q >> A;
	for (int i = 0; i < n; ++i) {
		cin >> v[i];
	}
	{
		ll sum = 0;
		for (int i = 0; i < n; ++i) {
			a[i] = i * v[i] + sum + A * v[i];
			sum += v[i];
		}
	}
	nb = (n + B - 1) / B;
	for (int i = 0; i < nb; ++i) {
		lb[i] = i * B;
		rb[i] = min(n, lb[i] + B);
	}
	for (int i = 0; i < nb; ++i) {
		for (int j = lb[i]; j < rb[i]; ++j) {
			ord[i].push_back(j);
		}
		sort(ord[i].begin(), ord[i].end(), [&](const int &j1, const int &j2) {
			return v[j1] < v[j2];
		});	
	}
	for (int i = 0; i < n; ++i) {
		fmn[i] = true;
		fmx[i] = false;
	}
	for (int i = 0; i < nb; ++i) {
		buildmin(i);
		buildmax(i);
	}
	ll suma = 0, sumv = 0;
	for (int R = 1; R <= n; ++R) {
		{
			ll mn = INF;
			int id = -1;
			for (int i = 0; i < nb; ++i) {
				ll curmn = getmin(i, R - 1);
				if (curmn < mn) {
					mn = curmn;
					id = i;
				}
			}
			for (int i : ord[id]) {
				if (fmn[i] && a[i] - v[i] * (R - 1) == mn) {
					suma += a[i];
					sumv += v[i];
					fmn[i] = false;
					fmx[i] = true;
					break;
				}
			}
			buildmin(id);
			buildmax(id);
		}
		while (true) {
			ll mn = INF;
			int idmn = -1;
			for (int i = 0; i < nb; ++i) {
				ll curmn = getmin(i, R - 1);
				if (curmn < mn) {
					mn = curmn;
					idmn = i;
				}
			}
			if (mn == INF) {
				break;
			}
			ll mx = -INF;
			int idmx = -1;
			for (int i = 0; i < nb; ++i) {
				ll curmx = getmax(i, R - 1);
				if (curmx > mx) {
					mx = curmx;
					idmx = i;
				}
			}
			if (mn >= mx) {
				break;
			}
			int kek = -1, lol = -1;
			for (int i : ord[idmn]) {
				if (fmn[i] && a[i] - v[i] * (R - 1) == mn) {
					kek = i;
					break;
				}
			}
			for (int i : ord[idmx]) {
				if (fmx[i] && a[i] - v[i] * (R - 1) == mx) {
					lol = i;
					break;
				}
			}	
			assert(kek != -1 && lol != -1);
			suma += a[kek];
			sumv += v[kek];
			suma -= a[lol];
			sumv -= v[lol];
			fmn[kek] = false;
			fmx[kek] = true;
			fmx[lol] = false;
			fmn[lol] = true;
			buildmin(idmn);
			buildmax(idmn);
			buildmin(idmx);
			buildmax(idmx);
		}
		ans[R] = suma - sumv * (R - 1);
	}
	while (q--) {
		int R;
		cin >> R;
		cout << ans[R] << "\n";
	}
	return 0;
}
