#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int N = 10005;
const ll W = 1e14;
const ll INF = 0x3f3f3f3f3f3f3f3f;
const int V = 1e5 + 7;

struct Edge {
	int v, u, f, c;
	ll w;
};

int n, k;
ll l[N], r[N];
vector<int> tr[2 * N];
vector<int> pref[2 * N], suf[2 * N];
int sz[2 * N];
vector<Edge> ed;
vector<int> g[V];
ll d[V], p[V];
int par[V];
int vv = 0, s, t;
int v1[N], v2[N];
bool inq[V];

void addedge(int v, int u, int c, ll w) {
	g[v].push_back(ed.size());
	ed.push_back({v, u, 0, c, w});
	g[u].push_back(ed.size());
	ed.push_back({u, v, 0, 0, -w});
}

void addkek(int i, int v) {
	int ind = partition_point(tr[v].begin(), tr[v].end(), [&](int j) {
		return l[j] <= r[i];
	}) - tr[v].begin(); 
	if (ind > 0) {
		addedge(v2[i], pref[v][ind - 1], 1, r[i]);
	}
	if (ind < sz[v]) {
		addedge(v2[i], suf[v][ind], 1, -r[i]);
	}
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cin >> n >> k;
	for (int i = 0; i < n; ++i) {
		cin >> l[i] >> r[i];
	}
	s = vv++;
	t = vv++;
	for (int i = 0; i < n; ++i) {
		v1[i] = vv++;
		v2[i] = vv++;
	}
	for (int i = 0; i < n; ++i) {
		for (int j = i + n; j > 0; j >>= 1) {
			tr[j].push_back(i);
		}
	}
	for (int i = 1; i < 2 * n; ++i) {
		if (tr[i].empty()) {
			continue;
		}
		sz[i] = tr[i].size();
		sort(tr[i].begin(), tr[i].end(), [&](const int &j1, const int &j2) {
			return l[j1] < l[j2];
		});
		pref[i].resize(tr[i].size());
		suf[i].resize(tr[i].size());
		for (int j = 0; j < sz[i]; ++j) {
			pref[i][j] = vv++;
			if (j > 0) {
				addedge(pref[i][j], pref[i][j - 1], k, 0);
			}
			addedge(pref[i][j], v1[tr[i][j]], 1, -l[tr[i][j]]);
		}
		for (int j = sz[i] - 1; j >= 0; --j) {
			suf[i][j] = vv++;
			if (j < sz[i] - 1) {
				addedge(suf[i][j], suf[i][j + 1], k, 0);
			}
			addedge(suf[i][j], v1[tr[i][j]], 1, l[tr[i][j]]);
		}
	}
	for (int i = 0; i < n; ++i) {
		addedge(s, v1[i], 1, 0);
		addedge(v1[i], v2[i], 1, -W);
		addedge(v2[i], t, 1, 0);
		for (int l = i + n + 1, r = 2 * n; l < r; l >>= 1, r >>= 1) {
			if (l & 1) {
				addkek(i, l);
				++l;
			}
			if (r & 1) {
				--r;
				addkek(i, r);
			}
		}
	}
	{
		memset(d, 0x3f, vv * sizeof d[0]);
		d[s] = 0;
		d[v1[0]] = 0;
		for (int i = 0; i < n; ++i) {
			d[v2[i]] = d[v1[i]] - W;
			if (i < n - 1) {
				d[v1[i + 1]] = d[v2[i]] + abs(r[i] - l[i + 1]);
			}
		}
		d[t] = d[v2[n - 1]];
		queue<int> q;
		inq[s] = true;
		q.push(s);
		inq[t] = true;
		q.push(t);
		for (int i = 0; i < n; ++i) {
			inq[v1[i]] = true;
			q.push(v1[i]);
			inq[v2[i]] = true;
			q.push(v2[i]);
		}
		while (!q.empty()) {
			int v = q.front();
			q.pop();
			inq[v] = false;
			for (int i : g[v]) {
				auto &e = ed[i];
				if (e.f == e.c) {
					continue;
				}
				if (d[v] + e.w < d[e.u]) {
					d[e.u] = d[v] + e.w;
					if (!inq[e.u]) {
						inq[e.u] = true;
						q.push(e.u);
					}
				}
			}
		}
		memcpy(p, d, vv * sizeof p[0]);
	}
	ll ans = 0;
	for (int kek = 0; kek < k; ++kek) {
		memset(d, 0x3f, vv * sizeof d[0]);
		memset(par, 255, vv * sizeof par[0]);
		priority_queue<pair<ll, int>, vector<pair<ll, int>>, greater<pair<ll, int>>> q;
		d[s] = 0;
		q.push({d[s], s});
		while (!q.empty()) {
			auto [dd, v] = q.top();
			q.pop();
			if (dd != d[v]) {
				continue;
			}
			for (int i : g[v]) {
				auto &e = ed[i];
				int u = e.u;
				ll w = e.w + p[v] - p[u];
				if (e.f < e.c) {
					assert(w >= 0);
					ll nd = d[v] + w;
					if (nd < d[u]) {
						d[u] = nd;
						par[u] = i;
						q.push({d[u], u});
					}
				}
			}
		}
		ans += d[t] + p[t];
		for (int i = 0; i < vv; ++i) {
			p[i] += d[i];
		}	
		for (int v = t; v != s; v = ed[par[v]].v) {
			ed[par[v]].f += 1;
			ed[par[v] ^ 1].f -= 1;
		}
	}
	cout << ans + n * W << endl;
	return 0;	
}
