#pragma GCC otpimize("Ofast,unroll-loops,fast-math")
#pragma GCC target("avx,avx2,fma")

#include <bits/stdc++.h>


using namespace std;


#define ll long long
#define flt double
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()


const ll inf = 1e10;
const ll infbg = 1e18;


struct edge{
    int to;
    int f;
    int rvi;
    bool c;
    
    edge() {}
    edge(int to, int c, ll w, int rvi) : to(to), f(0), rvi(rvi), c(c) {}
};



int n, k;
vector<int> l, r;


vector<vector<edge>> g;
vector<int> gto, gback;

void build_g(int n){
    g.assign(n, {});
}


void add_edge(int u, int v, int c, ll w){
    assert(u != v);
    int i = g[u].size();
    int j = g[v].size();
    g[u].push_back(edge(v, c, w, j));
    g[v].push_back(edge(u, 0, -w, i));
}


int n2;
vector<ll> d;
vector<int> p, pi;
vector<ll> pot;
vector<int> usd;


inline ll get_edge_cost(int u, int v){
    if(u >= n2 || v >= n2){
        return 0;
    }
    if(u + 1 == v && (v & 1)){
        return -inf;
    }
    if(v + 1 == u && (u & 1)){
        return inf;
    }
    u /= 2;
    v /= 2;
    if(u < v){
        return abs(r[u] - l[v]);
    }
    return -abs(r[v] - l[u]);
}


void djkstra(int v0, int n){
    d.assign(n, infbg);
    d[v0] = 0;
    usd.assign(n, false);
    while(1){
        ll mndst = infbg;
        int mn_dst_v = -1;
        for(int i = 0; i < n; i += 1){
            if(!usd[i] && d[i] < mndst){
                mndst = d[i];
                mn_dst_v = i;
            }
        }
        int v = mn_dst_v;
        if(v == -1){
            break;
        }
        usd[v] = true;
        for(int i = 0; i < g[v].size(); i += 1){
            auto &e = g[v][i];
            int to = e.to;
            if(e.f < e.c && !usd[to]){
                ll w = get_edge_cost(v, to) + pot[v] - pot[to];
                if(d[to] > d[v] + w){
                    d[to] = d[v] + w;
                    p[to] = v;
                    pi[to] = i;
                }
            }
        }
    }
}


ll min_cost_k_flow(int s, int t, int k, int n){
    p.resize(n);
    pi.resize(n);
    // pot.assign(n, 0);
    djkstra(s, n);
    for(int i = 0; i < n; i += 1){
        pot[i] += d[i];
    }
    ll rs = 0;
    for(int itr = 0; itr < k; itr += 1){
        int v = t;
        while(v != s){
            int pr = p[v];
            int pri = pi[v];
            auto &eto = g[pr][pri];
            auto &eback = g[v][eto.rvi];
            rs += get_edge_cost(pr, v);
            eto.f += 1;
            eback.f -= 1;
            v = pr;
        }
        djkstra(s, n);
        for(int i = 0; i < n; i += 1){
            pot[i] += d[i];
        }
    }
    return rs;
}


int32_t main(){
    if(1){
        ios::sync_with_stdio(0);
        cin.tie(0);
        cout.tie(0);
    }
    cin >> n >> k;
    l.resize(n);
    r.resize(n);
    for(int i = 0; i < n; i += 1){
        cin >> l[i] >> r[i];
    }
    n2 = n + n;
    build_g(n2 + 2);
    for(int i = 0; i < n; i += 1){
        add_edge(n2, i * 2, 1, 0);
        add_edge(i * 2, i * 2 + 1, 1, -inf);
        add_edge(i * 2 + 1, n2 + 1, 1, 0);
        for(int j = i + 1; j < n; j += 1){
            add_edge(i * 2 + 1, j * 2, 1, abs(r[i] - l[j]));
        }
    }
    pot.resize(n2 + 2);
    for(int i = 0; i < n2; i += 1){
        pot[i] = -inf * (i + 1);
    }
    pot[n2] = 0;
    pot[n2 + 1] = -inf * (n2 + 2);
    cout << min_cost_k_flow(n2, n2 + 1, k, n2 + 2) + n * inf << "\n";
    return 0;
}