#pragma GCC otpimize("Ofast,unroll-loops,fast-math")
#pragma GCC target("avx,avx2,fma")

#include <bits/stdc++.h>


using namespace std;


#define ll long long
#define flt double
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()


const ll inf = 1e10;
const ll infbg = 1e18;


struct edge{
    int to;
    int f;
    int rvi;
    bool c;
    
    edge() {}
    edge(int to, int c, ll w, int rvi) : to(to), f(0), rvi(rvi), c(c) {}
};



int n, k;
vector<int> l, r;


vector<vector<int>> c;
vector<vector<int>> f;
vector<int> gto, gback;


int n2;
vector<ll> d;
vector<int> p, pi;
vector<ll> pot;
vector<int> usd;


void build_g(int n){
    f.assign(n, vector<int>(n, 0));
    c.assign(n, vector<int>(n, 0));
}


void add_edge(int u, int v, int mc, ll w){
    c[u][v] = mc;
}


vector<int> get_edges(int v){
    vector<int> rs;
    if(v == n2){
        rs.reserve(n);
        for(int i = 0; i < n; i += 1){
            rs.push_back(i * 2);
        }
    } else if(v == n2 + 1){
        rs.reserve(n);
        for(int i = 0; i < n; i += 1){
            rs.push_back(i * 2 + 1);
        }
    } else if(v & 1){
        int i = v / 2;
        for(int j = i + 1; j < n; j += 1){
            rs.push_back(j * 2);
        }
        rs.push_back(n2 + 1);
        rs.push_back(v - 1);
    } else {
        rs.push_back(v + 1);
        int i = v / 2;
        for(int j = i - 1; j >= 0; j -= 1){
            rs.push_back(j * 2 + 1);
        }
        rs.push_back(0);
    }
    return rs;
}




inline ll get_edge_cost(int u, int v){
    if(u >= n2 || v >= n2){
        return 0;
    }
    if(u + 1 == v && (v & 1)){
        return -inf;
    }
    if(v + 1 == u && (u & 1)){
        return inf;
    }
    u /= 2;
    v /= 2;
    if(u < v){
        return abs(r[u] - l[v]);
    }
    return -abs(r[v] - l[u]);
}


void djkstra(int v0, int n){
    d.assign(n, infbg);
    d[v0] = 0;
    usd.assign(n, false);
    while(1){
        ll mndst = infbg;
        int mn_dst_v = -1;
        for(int i = 0; i < n; i += 1){
            if(!usd[i] && d[i] < mndst){
                mndst = d[i];
                mn_dst_v = i;
            }
        }
        int v = mn_dst_v;
        if(v == -1){
            break;
        }
        usd[v] = true;
        for(auto to: get_edges(v)){
            if(f[v][to] < c[v][to] && !usd[to]){
                ll w = get_edge_cost(v, to) + pot[v] - pot[to];
                if(d[to] > d[v] + w){
                    d[to] = d[v] + w;
                    p[to] = v;
                }
            }
        }
    }
}


ll min_cost_k_flow(int s, int t, int k, int n){
    p.resize(n);
    pi.resize(n);
    djkstra(s, n);
    for(int i = 0; i < n; i += 1){
        pot[i] += d[i];
    }
    ll rs = 0;
    for(int itr = 0; itr < k; itr += 1){
        int v = t;
        while(v != s){
            int pr = p[v];
            int pri = pi[v];
            rs += get_edge_cost(pr, v);
            f[pr][v] += 1;
            f[v][pr] -= 1;
            v = pr;
        }
        djkstra(s, n);
        for(int i = 0; i < n; i += 1){
            pot[i] += d[i];
        }
    }
    return rs;
}


int32_t main(){
    if(1){
        ios::sync_with_stdio(0);
        cin.tie(0);
        cout.tie(0);
    }
    cin >> n >> k;
    l.resize(n);
    r.resize(n);
    for(int i = 0; i < n; i += 1){
        cin >> l[i] >> r[i];
    }
    n2 = n + n;
    build_g(n2 + 2);
    for(int i = 0; i < n; i += 1){
        add_edge(n2, i * 2, 1, 0);
        add_edge(i * 2, i * 2 + 1, 1, -inf);
        add_edge(i * 2 + 1, n2 + 1, 1, 0);
        for(int j = i + 1; j < n; j += 1){
            add_edge(i * 2 + 1, j * 2, 1, abs(r[i] - l[j]));
        }
    }
    pot.resize(n2 + 2);
    for(int i = 0; i < n2; i += 1){
        pot[i] = -inf * (i + 1);
    }
    pot[n2] = 0;
    pot[n2 + 1] = -inf * (n2 + 2);
    cout << min_cost_k_flow(n2, n2 + 1, k, n2 + 2) + n * inf << "\n";
    return 0;
}