#pragma optimize("Ofast")
#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <iomanip>
#include <deque>

using namespace std;
typedef long long ll;
#define int long long

const int N = 50010;

int n, q, A;
int a[N];
int psum[N];
int ssum[N];
int ans = 0;

struct line
{
    int k = 0, a = 0;
    int defa = 0;
    int i = 0;

    line() {}

    line(int k, int a) : k(k), a(a) {}

    int val(int x)
    {
        return k * x + a;
    }

    bool operator<(const line& b) const
    {
        return make_pair(k, a) < make_pair(b.k, b.a);
    }

    bool operator==(const line& b) const
    {
        return i == b.i;
    }
};

struct nset
{
    vector <line> a;
    int ad = 0;
    int sumdef = 0;

    nset() {}

    line gtmin(int r)
    {
        line ans = a[0];
        for (int i = 1; i < a.size(); ++i) if (a[i].val(r) < ans.val(r))
        {
            ans = a[i];
        }
        ans.a += ad;
        return ans;
    }

    line gtmax(int r)
    {
        line ans = a[0];
        for (int i = 1; i < a.size(); ++i) if (a[i].val(r) > ans.val(r))
        {
            ans = a[i];
        }
        ans.a += ad;
        return ans;
    }

    int size()
    {
        return a.size();
    }

    line erase(int i)
    {
        for (int j = 0; j < a.size(); ++j)
        {
            if (a[j].i == i)
            {
                auto ans = a[j];
                ans.a += ad;
                a.erase(a.begin() + j);
                sumdef -= ans.defa;
                return ans;
            }
        }
        assert(false);
    }

    void insert(line ln)
    {
        ln.a -= ad;
        a.push_back(ln);
        sumdef += ln.defa;
    }

    void addall(int v)
    {
        ad += v;
    }

    bool count(int r)
    {
        for (auto i : a) if (i.i == r) return true;
        return false;
    }
};

line val[N];

nset lch, ln, rch, rn;

int sv[N];

signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);

    cin >> n >> q >> A;
    for (int i = 1; i <= n; ++i)
    {
        cin >> a[i];
        psum[i] = a[i] + psum[i - 1];
    }

    for (int i = n; i >= 1; --i)
    {
        ssum[i] = ssum[i + 1] + a[i];
    }

    for (int i = 1; i <= n; ++i)
    {
        val[i] = line(-a[i], a[i] * A + psum[i - 1] + a[i] * (i + 1));
        val[i].i = i;
        val[i].defa = a[i];
        rn.insert(val[i]);
    }

    for (int r = 2; r <= n + 1; ++r)
    {
        if (rch.count(r - 1))
        {
            auto got = rch.erase(r - 1);
            ans -= got.val(r - 1);
            auto g2 = lch.gtmax(r - 1);
            auto g3 = lch.erase(g2.i);
            ln.insert(g3);
            ans -= g3.val(r - 1);
        }
        else
        {
            rn.erase(r - 1);
        }

        lch.addall(a[r - 1]);
        ln.addall(a[r - 1]);
        rch.addall(-a[r - 1]);
        rn.addall(-a[r - 1]);
        ans += a[r - 1] * A;
        ans -= rch.sumdef;
        ans += lch.sumdef;

        auto nw = line(a[r - 1], -a[r - 1] * A - a[r - 1] * (r - 1));
        nw.i = r - 1;
        nw.defa = a[r - 1];
        ln.insert(nw);
        bool found = false;

        while (ln.size() && lch.size() && ln.gtmin(r).val(r) < lch.gtmax(r).val(r))
        {
            ans -= lch.gtmax(r).val(r);
            ans += ln.gtmin(r).val(r);
            int u = lch.gtmax(r).i;
            auto got = lch.erase(u);
            ln.insert(got);
            u = ln.gtmin(r).i;
            got = ln.erase(u);
            lch.insert(got);
            found = true;
        }
        while (rn.size() && rch.size() && rn.gtmin(r).val(r) < rch.gtmax(r).val(r))
        {
            ans -= rch.gtmax(r).val(r);
            ans += rn.gtmin(r).val(r);
            int u = rch.gtmax(r).i;
            auto got = rch.erase(u);
            rn.insert(got);
            u = rn.gtmin(r).i;
            got = rn.erase(u);
            rch.insert(got);
            found = true;
        }

        while (lch.size() && lch.gtmax(r).val(r) + rch.gtmax(r).val(r) > 0)
        {
            ans -= lch.gtmax(r).val(r);
            ans -= rch.gtmax(r).val(r);
            int u = lch.gtmax(r).i;
            auto got = lch.erase(u);
            ln.insert(got);
            u = rch.gtmax(r).i;
            got = rch.erase(u);
            rn.insert(got);
            found = true;
        }
        while (ln.size() && rn.size() && ln.gtmin(r).val(r) + rn.gtmin(r).val(r) < 0)
        {
            ans += ln.gtmin(r).val(r);
            ans += rn.gtmin(r).val(r);
            int u = ln.gtmin(r).i;
            auto got = ln.erase(u);
            lch.insert(got);
            u = rn.gtmin(r).i;
            got = rn.erase(u);
            rch.insert(got);
            found = true;
        }



        sv[r - 1] = ans;
    }

    while (q--)
    {
        int r;
        cin >> r;
        cout << sv[r] << '\n';
    }

    return 0;
}