#include <iostream>
#include <vector>
#include <map>
#include <iomanip>
using namespace std;
map<pair<int,int>,int > mp;
int n;
long double p;
int gpos(int a, int b) {
	return 6 * a + b;
}

vector<map<int ,long double> > mtx(37);
int interesting = 0;
long double ans = 1e9;

void check() {
	for (int i = 0; i < 37; i++) {
		mtx[i].clear();
	}
	for (int a = 0; a <= n; a++) {
		for (int b = 0; b <= n; b++) {
			int pos = gpos(a, b);
			if (a >= n && b >= n) {
				mtx[pos][-1] =0;
			}
			else if (a == b) {
				mtx[pos][gpos(a + 1, b)] = p;
				mtx[pos][gpos(a, b + 1)] = 1 - p;
				mtx[pos][-1] = 1;
			}
			else if (mp[{a, b}] == 0) {
				mtx[pos][gpos(a + 1, b)] += p;
				mtx[pos][-1] += p;

				long double chance = 1-p;
				for (int i = 0; i < 1000; i++) {
					int napos = max((a - i), 0);
					int poss = gpos(napos, b);
					long double curchance = (1 - p) * chance;
					mtx[pos][poss] += curchance;
					mtx[pos][-1] += curchance*(i+2);
					chance *= p;
				}
			}
			else if (mp[{a, b}] == 1) {
				mtx[pos][gpos(a, b+1)] += (1 - p);
				mtx[pos][-1] += 1 - p;

				long double chance = p;

				for (int i = 0; i < 1000; i++) {
					int napos = max((b - i), 0);
					int poss = gpos(a, napos);
					long double curchance = p * chance;
					mtx[pos][poss] += curchance;
					mtx[pos][-1] += curchance*(i+2);
					chance *= (1 - p);
				}
			}
		}
	}
	

	vector<int> vis(37,0);
	for (int i = 0; i < 37; i++) {
		if (i != interesting&&!vis[i]) {
			vis[i] = true;
			long double divide = 1 - mtx[i][i];
			vector<pair<int, long double> > ftr;
			for (auto h : mtx[i]) {
				if (h.first != i) {
					ftr.push_back(h);
				}
			}
			for (int j = 0; j < 37; j++) {
				if (!vis[j]) {
					long double taken = mtx[j][i];
					mtx[j].erase(i);
					for (auto h : ftr) {
						mtx[j][h.first] += taken * h.second / divide;
					}
				}

			}
		}
	}
	ans = min(ans, mtx[interesting][-1]/(1-mtx[interesting][interesting]));
}

void prb(int a, int b) {
	
	if (a ==n) {
		mp[{a, b}] = 1;
		if (b < n) {
			prb(a, b + 1);
		}
		else {
			check();
		}
	}
	else if (b ==n) {
		mp[{a, b}] = 0;
		prb(a + 1, 0);
	}
	else {
		if (p >= 0.5) {
			mp[{a, b}] = 1;
			if (b < n) {
				prb(a, b + 1);
			}
			else {
				prb(a + 1, 0);
			}
		}
		else {
			mp[{a, b}] = 0;
			if (b < n) {
				prb(a, b + 1);
			}
			else {
				prb(a + 1, 0);
			}
		}
	}
	
}


void prb2(int a, int b) {

	if (a == n) {
		mp[{a, b}] = 1;
		if (b < n) {
			prb2(a, b + 1);
		}
		else {
			check();
		}
	}
	else if (b == n) {
		mp[{a, b}] = 0;
		prb2(a + 1, 0);
	}
	else {
		if (a>=b) {
			mp[{a, b}] = 1;
			if (b < n) {
				prb2(a, b + 1);
			}
			else {
				prb2(a + 1, 0);
			}
		}
		else {
			mp[{a, b}] = 0;
			if (b < n) {
				prb2(a, b + 1);
			}
			else {
				prb2(a + 1, 0);
			}
		}
	}

}



int main() {
	cout << fixed << setprecision(12);
	cin >> p;
	int a, b;
	cin >> n >> a >> b;
	interesting = gpos(a, b);
	prb(0, 0);
	prb2(0, 0);
	cout << ans;
}