#include <iostream>
#include <random>
#include <queue>
using namespace std;
using ld = long double;

const int MAXN = 103;
const int MAXM = MAXN * MAXN * 3;
int node_num[MAXN][MAXN][3];
pair<pair<int, int>, int> num_node[MAXM];
pair<int, int> edges[MAXM];

mt19937 rng(time(0));

ld get_ans(ld p, int n, int s, int t) {
    if (s == t)
        return 0;
    vector<ld> coefs(n, 0);
    coefs[s] = 1;
    const ld EPS = 1e-16;
    queue<int> vs;
    vs.push(s);
    ld ans = 0;
    coefs[t] = 1;
    while (vs.size()) {
        int v = vs.front();
        vs.pop();
        if (v == t)
            continue;
        ld cf = coefs[v];
        ans += coefs[v];
        coefs[v] = 0;
        ld& e1 = coefs[edges[v].first];
        if (e1 < EPS && e1 + cf * p > EPS) {
            vs.push(edges[v].first);
        }
        e1 += cf * p;
        ld& e2 = coefs[edges[v].second];
        if (e2 < EPS && e2 + cf * (1 - p) > EPS) {
            vs.push(edges[v].second);
        }
        e2 += cf * (1 - p);
    }
    return ans;
}

signed main() {
    ld p;
    int n, l, r;
    cin >> p >> n >> l >> r;
    if (p > .5) {
        swap(l, r);
        p = 1 - p;
    }
    int nodecnt = 0;
    for (int l0 = 0; l0 <= n; ++l0) {
        for (int r0 = 0; r0 <= n; ++r0) {
            for (int t = 0; t < 3; ++t) {
                node_num[l0][r0][t] = nodecnt;
                num_node[nodecnt++] = {{l0, r0}, t};
            }
        }
    }
    ld ans = 1e9;
    for (int m = 0; m < (1 << (2 * n)); ++m) {
        if (__builtin_popcount(m) != n)
            continue;
        int hoh = 0;
        vector<int> dif;
        for (int i = 0; i < (2 * n); ++i) {
            if (m & (1 << i))
                ++hoh;
            else
                dif.push_back(hoh);
        }
        for (int l0 = 0; l0 <= n; ++l0) {
            for (int r0 = 0; r0 <= n; ++r0) {
                for (int t = 0; t < 3; ++t) {
                    int ndi = node_num[l0][r0][t];
                    if (t == 0) {
                        if (l0 == n && r0 == n)
                            continue;
                        if (l0 == r0) {
                            edges[ndi] = {node_num[l0 + 1][r0][0], node_num[l0][r0 + 1][0]};
                        } else if (l0 == n || (r0 < l0 && l0 <= r0 + dif[l0])) {
                            edges[ndi] = {node_num[l0][r0][1], node_num[l0][r0 + 1][0]};
                        } else {
                            edges[ndi] = {node_num[l0 + 1][r0][0], node_num[l0][r0][2]};
                        }
                    } else if (t == 1) {
                        edges[ndi] = {node_num[l0][r0][0], node_num[l0][max(0, r0 - 1)][1]};
                    } else {
                        edges[ndi] = {node_num[max(0, l0 - 1)][r0][2], node_num[l0][r0][0]};
                    }
                }
            }
        }
        ans = min(ans, get_ans(p, nodecnt, node_num[l][r][0], node_num[n][n][0]));
    }
    printf("%.20Lf\n", ans);
    //cout << setprecision(12) << get_ans(p, nodecnt, node_num[l][r][0], node_num[n][n][0]) << '\n';
}
