#include <iostream>
#include <random>
#include <queue>
using namespace std;
using ld = long double;

const int MAXN = 103;
const int MAXM = MAXN * MAXN * 3;
int node_num[MAXN][MAXN][3];
pair<pair<int, int>, int> num_node[MAXM];
pair<int, int> edges[MAXM];

mt19937 rng(time(0));

int brute_force(ld p, int n, int l, int r, int t) {
    if (l == n && r == n)
        return 0;
    ld x = .5 * rng() / RAND_MAX;
    bool lft = x < p;
    if (t == 1) {
        if (lft)
            return 1 + brute_force(p, n, l, r, 0);
        return 1 + brute_force(p, n, l, max(r - 1, 0), t);
    }
    if (t == 2) {
        if (!lft)
            return 1 + brute_force(p, n, l, r, 0);
        return 1 + brute_force(p, n, max(l - 1, 0), r, t);
    }
    if (l == r) {
        if (lft)
            return 1 + brute_force(p, n, l + 1, r, 0);
        return 1 + brute_force(p, n, l, r + 1, 0);
    }
    if (l == n) {
        if (lft)
            return 1 + brute_force(p, n, l, r, 1);
        return 1 + brute_force(p, n, l, r + 1, 0);
    }
    if (lft)
        return 1 + brute_force(p, n, l + 1, r, 0);
    return 1 + brute_force(p, n, l, r, 2);
}

ld get_ans(ld p, int n, int s, int t) {
    if (s == t)
        return 0;
    vector<ld> coefs(n, 0);
    coefs[s] = 1;
    const ld EPS = 1e-33;
    queue<int> vs;
    vs.push(s);
    ld ans = 0;
    coefs[t] = 1;
    while (vs.size()) {
        int v = vs.front();
        vs.pop();
        if (v == t)
            continue;
        ld cf = coefs[v];
        ans += coefs[v];
        coefs[v] = 0;
        ld& e1 = coefs[edges[v].first];
        if (e1 < EPS && e1 + cf * p > EPS) {
            vs.push(edges[v].first);
        }
        e1 += cf * p;
        ld& e2 = coefs[edges[v].second];
        if (e2 < EPS && e2 + cf * (1 - p) > EPS) {
            vs.push(edges[v].second);
        }
        e2 += cf * (1 - p);
    }
    return ans;
}

signed main() {
    ld p;
    int n, l, r;
    cin >> p >> n >> l >> r;
    if (p > .5) {
        swap(l, r);
        p = 1 - p;
    }
    int nodecnt = 0;
    for (int l0 = 0; l0 <= n; ++l0) {
        for (int r0 = 0; r0 <= n; ++r0) {
            for (int t = 0; t < 3; ++t) {
                node_num[l0][r0][t] = nodecnt;
                num_node[nodecnt++] = {{l0, r0}, t};
            }
        }
    }
    for (int l0 = 0; l0 <= n; ++l0) {
        for (int r0 = 0; r0 <= n; ++r0) {
            for (int t = 0; t < 3; ++t) {
                int ndi = node_num[l0][r0][t];
                if (t == 0) {
                    if (l0 == n && r0 == n)
                        continue;
                    if (l0 == r0) {
                        edges[ndi] = {node_num[l0 + 1][r0][0], node_num[l0][r0 + 1][0]};
                    } else if (l0 == n || r0 < l0) {
                        edges[ndi] = {node_num[l0][r0][1], node_num[l0][r0 + 1][0]};
                    } else {
                        edges[ndi] = {node_num[l0 + 1][r0][0], node_num[l0][r0][2]};
                    }
                } else if (t == 1) {
                    edges[ndi] = {node_num[l0][r0][0], node_num[l0][max(0, r0 - 1)][1]};
                } else {
                    edges[ndi] = {node_num[max(0, l0 - 1)][r0][2], node_num[l0][r0][0]};
                }
            }
        }
    }
    printf("%.20Lf\n", get_ans(p, nodecnt, node_num[l][r][0], node_num[n][n][0]));
    //cout << setprecision(12) << get_ans(p, nodecnt, node_num[l][r][0], node_num[n][n][0]) << '\n';
}
