#include <iostream>
#include <random>
#include <queue>
using namespace std;
using ld = long double;

const int MAXN = 103;
const int MAXM = MAXN * MAXN * 3;
int node_num[MAXN][MAXN][3];
pair<pair<int, int>, int> num_node[MAXM];
pair<int, int> edges[MAXM];
int nodecnt = 0;

mt19937 rng(time(0));

ld get_ans(ld p, int n, int s, int t) {
    if (s == t)
        return 0;
    vector<ld> coefs(n, 0);
    coefs[s] = 1;
    const ld EPS = 1e-33;
    queue<int> vs;
    vs.push(s);
    ld ans = 0;
    coefs[t] = 1;
    while (vs.size()) {
        int v = vs.front();
        vs.pop();
        if (v == t)
            continue;
        ld cf = coefs[v];
        ans += coefs[v];
        coefs[v] = 0;
        ld& e1 = coefs[edges[v].first];
        if (e1 < EPS && e1 + cf * p > EPS) {
            vs.push(edges[v].first);
        }
        e1 += cf * p;
        ld& e2 = coefs[edges[v].second];
        if (e2 < EPS && e2 + cf * (1 - p) > EPS) {
            vs.push(edges[v].second);
        }
        e2 += cf * (1 - p);
    }
    return ans;
}

ld get_ansho(ld p, int n, int l, int r) {
    if (r == n && l == n)
        return 0;
    if (l > r) {
        return get_ansho(1 - p, n, r, l);
    }
    if (r < n)
        return get_ansho(p, n, l, r + 1) + 1 + (r + 1) * (4 * p - 2) / (1 - p) ;
    return get_ansho(p, n, l + 1, r) + 2 + (l + 1) * (2 * (1 - p)) / p;
}

signed main() {
    ld p;
    int n, l, r;
    cin >> p >> n >> l >> r;
    printf("%.20Lf\n", get_ansho(p, n, l, r));
    return 0;
    if (l < r) {
        swap(l, r);
        p = 1 - p;
    }
    for (int l0 = 0; l0 <= n; ++l0) {
        for (int r0 = 0; r0 <= n; ++r0) {
            for (int t = 0; t < 3; ++t) {
                node_num[l0][r0][t] = nodecnt;
                num_node[nodecnt++] = {{l0, r0}, t};
            }
        }
    }
    for (int l0 = 0; l0 <= n; ++l0) {
        for (int r0 = 0; r0 <= n; ++r0) {
            for (int t = 0; t < 3; ++t) {
                int ndi = node_num[l0][r0][t];
                if (t == 0) {
                    if (l0 == n && r0 == n)
                        continue;
                    if (l0 == r0) {
                        edges[ndi] = {node_num[l0 + 1][r0][0], node_num[l0][r0 + 1][0]};
                    } else if (r0 < l0) {
                        edges[ndi] = {node_num[l0][r0][1], node_num[l0][r0 + 1][0]};
                    } else {
                        edges[ndi] = {node_num[l0 + 1][r0][0], node_num[l0][r0][2]};
                    }
                } else if (t == 1) {
                    edges[ndi] = {node_num[l0][r0][0], node_num[l0][max(0, r0 - 1)][1]};
                } else {
                    edges[ndi] = {node_num[max(0, l0 - 1)][r0][2], node_num[l0][r0][0]};
                }
            }
        }
    }
    vector<vector<ld>> anss(n + 1, vector<ld>(n + 1, 0));
    for (int i = 0; i <= n; ++i) {
        for (int j = 0; j <= n; ++j) {
            anss[i][j] = get_ans(p, nodecnt, node_num[i][j][0], node_num[n][n][0]);
            cout << anss[i][j] - get_ansho(p, n, i, j) << ' ';
        }
        //for (int j = i; j < n; ++j) {
            //cout << anss[i][j] - anss[i][j + 1] - 1 - (j + 1) * (4 * p - 2) / (1 - p) << ' ';;
        //}
    }
    cout << endl;
    for (int i = 0; i <= n; ++i) {
        for (int j = 0; j <= n; ++j) {
            printf("%8.4Lf ", anss[i][j]);
            if (j < n)
                printf("{%8.4Lf} ", anss[i][j] - anss[i][j + 1]);
        }
        printf("\n");
        if (i < n) {
            for (int j = 0; j <= n; ++j) {
                printf("{%7.4Lf}           ", anss[i][j] - anss[i + 1][j]);
            }
        }
        printf("\n");
    }
    printf("%.20Lf\n", get_ans(p, nodecnt, node_num[l][r][0], node_num[n][n][0]));
}
