#include <bits/extc++.h>
using namespace std;
using namespace __gnu_pbds;

#define fast ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define all(a) a.begin(), a.end()
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using vi = vector<int>;
using oset = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

struct edge {
    ll f, c, w;
    edge(ll f = 0, ll c = 0, ll w = 0): f(f), c(c), w(w) {}
};

const ll INF = 1e18 + 100, WINF = 1e9 + 10;
int n;
vector<vector<pii>> g;
vector<edge> e;
vector<ll> d, x;
vi o;
vector<bool> bus;

void dfs(int u) {
    bus[u] = true;
    for (auto to: g[u]) {
        if (e[to.second].f < e[to.second].c && !bus[to.first])
            dfs(to.first);
    }
    o.push_back(u);
}

void calc() {
    x.assign(n, INF);
    bus.assign(n, false);
    dfs(0);
    reverse(all(o));
    x[o[0]] = 0;
    for (int i: o) {
        for (auto to: g[i]) {
            if (e[to.second].f < e[to.second].c)
                x[to.first] = min(x[to.first], x[i] + e[to.second].w);
        }
    }
}

void dijkstra() {
    d.assign(n, INF);
    d[0] = 0;
    vector<bool> used(n, false);
    for (int i = 0; i < n; ++i) {
        int u = -1;
        for (int v = 0; v < n; ++v) {
            if (!used[v] && (u == -1 || d[v] < d[u]))
                u = v;
        }
        if (d[u] == INF)
            break;
        for (auto to: g[u]) {
            if (e[to.second].f < e[to.second].c && d[u] + e[to.second].w + x[u] - x[to.first] < d[to.first])
                d[to.first] = d[u] + e[to.second].w + x[u] - x[to.first];
        }
        used[u] = true;
    }
    for (int i = 0; i < n; ++i) {
        if (d[i] != INF)
            x[i] += d[i];
    }
}

void bfs() {
    d.assign(n, INF);
    vector<pii> prv(n, {-1, -1});
    d[0] = 0;
    queue<int> q;
    q.push(0);
    while (!q.empty()) {
        int u = q.front();
        q.pop();
        for (auto to: g[u]) {
            if (e[to.second].f < e[to.second].c && e[to.second].w + x[u] - x[to.first] == 0 && d[u] + 1 < d[to.first]) {
                d[to.first] = d[u] + 1;
                prv[to.first] = {u, to.second};
                q.push(to.first);
            }
        }
    }
    pii p = prv[1];
    while (p.first != -1) {
        ++e[p.second].f;
        --e[p.second ^ 1].f;
        p = prv[p.first];
    }
}

void add_edge(int u, int v, ll w) {
    g[u].emplace_back(v, e.size());
    e.emplace_back(0, 1, w);
    g[v].emplace_back(u, e.size());
    e.emplace_back(0, 0, -w);
}

int main() {
    fast;
    int k;
    cin >> n >> k;
    g.resize(n * 2 + 2);
    for (int i = 1; i <= n; ++i) {
        add_edge(0, i * 2, 0);
        add_edge(i * 2, i * 2 + 1, -WINF);
        add_edge(i * 2 + 1, 1, 0);
    }
    vector<pii> a(n);
    for (int i = 0; i < n; ++i)
        cin >> a[i].first >> a[i].second;
    for (int i = 1; i <= n; ++i) {
        for (int j = i + 1; j <= n; ++j)
            add_edge(i * 2 + 1, j * 2, abs(a[i - 1].second - a[j - 1].first));
    }
    n = n * 2 + 2;
    calc();
    while (k--) {
        bfs();
        dijkstra();
    }
    ll ans = 0;
    for (auto ed: e) {
        //cout << ed.f << ' ' << ed.c << ' ' << ed.w << '\n';
        if (ed.f == 1 && ed.w > 0)
            ans += ed.w;
    }
    cout << ans << '\n';
}
