#include <bits/stdc++.h>

using namespace std;

struct Edge {
    int to, flow, c, p, ind;

    Edge(int _to, int _c, int _p, int _ind) {
        to = _to, flow = 0, c = _c, p = _p, ind = _ind;
    }
};

const int maxn = 1e4 + 5;
const long long inf = 1e18;

vector<Edge> g[maxn];

void add_edge(int u, int v, int p) {
    g[u].emplace_back(v, 1, p, g[v].size());
    g[v].emplace_back(u, 0, -p, g[u].size() - 1);
}

long long dist[maxn], f[maxn];
int pr[maxn];
bool used[maxn];

int s, t, sz;

long long FB() {
    for (int i = 0; i < sz; ++i) {
        dist[i] = inf;
        pr[i] = -1;
        used[i] = false;
    }
    queue<int> q;
    dist[t] = 0;
    q.push(t);
    used[t] = true;
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        used[v] = false;
        for (auto e : g[v]) {
            if (g[e.to][e.ind].flow < g[e.to][e.ind].c && dist[e.to] > dist[v] + g[e.to][e.ind].p) {
                dist[e.to] = dist[v] + g[e.to][e.ind].p;
                pr[e.to] = v;
                if (!used[e.to]) {
                    q.push(e.to);
                    used[e.to] = true;
                }
            }
        }
    }
    for (int i = 0; i < sz; ++i) {
        f[i] = dist[i];
    }
    return dist[s];
}

long long find_short() {
    for (int i = 0; i < sz; ++i) {
        dist[i] = inf;
        pr[i] = -1;
    }
    set<pair<long long, int>> ss;
    dist[t] = 0;
    for (int i = 0; i < sz; ++i) {
        ss.insert({dist[i], i});
    }
    while (!ss.empty()) {
        int v = ss.begin()->second;
        ss.erase(ss.begin());
        if (dist[v] == inf) {
            break;
        }
        for (auto e : g[v]) {
            long long cost = g[e.to][e.ind].p + f[v] - f[e.to];
            if (g[e.to][e.ind].flow < g[e.to][e.ind].c && dist[e.to] > dist[v] + cost) {
                ss.erase({dist[e.to], e.to});
                dist[e.to] = dist[v] + cost;
                pr[e.to] = v;
                ss.insert({dist[e.to], e.to});
            }
        }
    }
    for (int i = 0; i < sz; ++i) {
        dist[i] = dist[i] - f[i];
        f[i] = dist[i];
    }
    return dist[s];
}

void augment() {
    int nw = s;
    while (nw != t) {
        for (auto &e : g[nw]) {
            if (e.to == pr[nw]) {
                e.flow++;
                g[e.to][e.ind].flow--;
                nw = e.to;
                break;
            }
        }
    }
}

void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> l(n), r(n);
    for (int i = 0; i < n; ++i) {
        cin >> l[i] >> r[i];
    }
    sz = n * 2 + 2;
    s = n * 2, t = n * 2 + 1;
    for (int i = 0; i < n; ++i) {
        add_edge(s, i, 0);
        for (int j = i + 1; j < n; ++j) {
            add_edge(i, n + j, abs(l[j] - r[i]));
        }
        add_edge(n + i, t, 0);
    }
    long long ans = 0;
    long long val = FB();
    for (int i = 0; i < n - k; ++i) {
        // cout << val << endl;
        ans += val;
        augment();
        find_short();
    }
    cout << ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}
