#include <iostream>
#include <vector>
#include <algorithm>
#include <utility>
#include <numeric>
#include <random>
#include <queue>
#include <cmath>

#define int long long
#define all(a) a.begin(), a.end()

using namespace std;

mt19937_64 rnd(228);

template<typename T> void input(T& a, int i = 0, int j = -1) {
	if (j == -1)
		j = a.size() - 1;
	for (int k = i; k <= j; ++k)
		cin >> a[k];
}
template<typename T> bool minravno(T& a, T b) {
	if (b < a) {
		a = b;
		return true;
	}
	return false;
}

typedef vector<int> vi;
typedef vector<vi> vvi;
typedef pair<int, int> pi;
typedef vector<pi> vpi;
typedef double ld;
typedef vector<ld> vld;
typedef vector<vld> vvld;

struct edge {
	int v, u, c, p, f;
};

int n, k;
vector<edge> e;
vvi g;

void add_edge(int v, int u, int p) {
	e.push_back({ v, u, 1, p, 0 });
	g[v].push_back(e.size() - 1);
	e.push_back({ u, v, 0, -p, 0 });
	g[u].push_back(e.size() - 1);
}

pair<vi, vi> ford() {
	bool flag = true;
	vi d(2 * n + 2, 1e18), pr(2 * n + 2);
	d[0] = 0;
	while (flag) {
		queue<int> q;
		flag = false;
		q.push(0);
		while (q.size()) {
			int v = q.front();
			q.pop();
			for (auto i : g[v]) {
				auto [tmp, u, c, p, f] = e[i];
				if (f == c)
					continue;
				if (minravno(d[u], d[v] + p)) {
					q.push(u);
					pr[u] = i;
					flag = true;
				}
			}
		}
	}
	return { d, pr };
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	cin >> n >> k;
	g.resize(2 * n + 2);
	for (int i = 1; i <= n; ++i) {
		add_edge(0, i, 0);
		add_edge(i + n, 2 * n + 1, 0);
	}
	vpi a = { {0, 0} };
	for (int i = 0; i < n; ++i) {
		int x, y;
		cin >> x >> y;
		a.push_back({ x, y });
	}
	for (int i = 1; i <= n; ++i) {
		for (int j = i + 1; j <= n; ++j) {
			add_edge(i, j + n, abs(a[i].second - a[j].first));
		}
	}
	int f = 0, p = 0;
	while (f < n - k) {
		auto [d, pr] = ford();
		int v = 2 * n + 1;
		p += d[2 * n + 1];
		while (v) {
			int i = pr[v];
			e[i].f++;
			e[i ^ 1].f--;
			v = e[i].v;
		}
		f++;
	}
	cout << p;
	return 0;
}