//#pragma GCC optimize("O3")
#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;

struct State {
    int pos;
    bool wrong;
    bool operator==(const State &other) const {
        return pos == other.pos && wrong == other.wrong;
    }
};

mt19937 rnd(228337);
uniform_real_distribution ud(0.0, 1.0);

bool goes_to_left(ld prob) {
    return ud(rnd) <= prob;
}

constexpr int MAX_STEP = 20337;
constexpr int MAX_N = 16;

ld dp[MAX_STEP + 1][MAX_N][MAX_N][3];

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    cout << setprecision(15) << fixed;
    //cerr << setprecision(15) << fixed;
    double p;
    int n, l, r;
    cin >> p >> n >> l >> r;

    if (l == n && r == n) {
        cout << "0\n";
        return 0;
    }

    ld ans = 0;

    dp[0][l][r][0] = 1;

    for (int i = 0; i < MAX_STEP; ++i) {
        for (int state_l = 0; state_l <= n; ++state_l) {
            for (int state_r = 0; state_r <= n; ++state_r) {
                if (state_l == state_r && state_r == n) continue;
                if (dp[i][state_l][state_r][0] != 0) {
                    // no wrong
                    if (state_l <= state_r) {
                        dp[i + 1][state_l + 1][state_r][0] += dp[i][state_l][state_r][0] * p;
                        if (state_r == state_l) {
                            dp[i + 1][state_l][state_r + 1][0] += dp[i][state_l][state_r][0] * (1 - p);
                        } else {
                            dp[i + 1][state_l][state_r][2] += dp[i][state_l][state_r][0] * (1 - p);
                        }
                    } else {
                        dp[i + 1][state_l][state_r][1] += dp[i][state_l][state_r][0] * p;
                        dp[i + 1][state_l][state_r + 1][0] += dp[i][state_l][state_r][0] * (1 - p);
                    }
                }
                if (dp[i][state_l][state_r][1] != 0) {
                    // fix left;
                    dp[i + 1][state_l][state_r][0] += dp[i][state_l][state_r][1] * p;
                    dp[i + 1][state_l][max(0, state_r - 1)][1] += dp[i][state_l][state_r][1] * (1 - p);
                }
                if (dp[i][state_l][state_r][2] != 0) {
                    // fix right;
                    dp[i + 1][state_l][state_r][0] += dp[i][state_l][state_r][2] * (1 - p);
                    dp[i + 1][max(0, state_l - 1)][state_r][2] += dp[i][state_l][state_r][2] * p;
                }
            }
        }
        ans += dp[i][n][n][0] * i;
//        if (dp[i][n][n][0] * i < 1e-10) break;
        if (i != 0 && dp[i - 1][n][n][0] != 0) {
//            //cerr << dp[i][n][n][0] / dp[i - 1][n][n][0] << '\n';
        }
        if (i > 1) {
            if (dp[i - 2][n][n][0] != 0 && dp[i][n][n][0] / dp[i - 1][n][n][0] == dp[i - 1][n][n][0] / dp[i - 2][n][n][0]) {
                ld ratio = (dp[i][n][n][0] / dp[i - 1][n][n][0]);
                //cerr << i << ' ' << (long double)ratio << '\n';
                ld prev = dp[i][n][n][0];
                for (int j = i + 1; clock() < 0.140 * CLOCKS_PER_SEC; ++j) {
                    prev *= ratio;
                    ans += prev * j;
                }
                break;
            }
        }

    }
    cout << (long double)ans << '\n';

    return 0;
}
