#include <bits/stdc++.h>
using namespace std;
using ll = long long;

struct Edge {
    int from, to, w;
    bool operator<(const Edge &other) const {
        return w < other.w;
    }
};

struct DSU {
    vector<int> data;
    explicit DSU (int n) {
        data.resize(n, -1);
    }
    int get_parent(int u) {
        if (data[u] < 0) return u;
        return data[u] = get_parent(data[u]);
    }
    bool unite(int u, int v) {
        u = get_parent(u);
        v = get_parent(v);
        if (u == v) return false;
        if (data[u] < data[v]) {
            swap(u, v);
        }
        if (data[u] == data[v]) --data[v];
        data[u] = v;
        return true;
    }
};

int main() {
    int n, k;
    cin >> n >> k;
    vector<pair<int, int>> people(n);
    for (int i = 0; i < n; ++i) {
        cin >> people[i].first >> people[i].second;
    }
    vector<Edge> graph;
    graph.reserve(n * (n + 1) / 2);
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            graph.push_back({i, j, abs(people[i].second - people[j].first)});
        }
    }
    DSU snm(n);
    std::sort(graph.begin(), graph.end());
    int cnt = n;
    ll ans = 0;
    for (int i = 0; i < graph.size() && cnt > k; ++i) {
        if (snm.unite(graph[i].from, graph[i].to)) {
            ans += graph[i].w;
            --cnt;
        }
    }
    cout << ans;
    return 0;
}
