#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_map>
//#include <unordered_set>
#include <deque>
#include <bitset>
#include <iomanip>
#include <queue>
#include <cmath>
#include <ctime>
#include <numeric>
#include <string>

using namespace std;

typedef long long ll;
//typedef __int128_t ll;
typedef long double ld;
#define all(x) x.begin(), x.end()
//#define break_(x) {x; return;}
const ll MOD = 1000000007;
const ll inf = 1e14;
const ld eps = 1e-9;
//const ll MOD2 = 998244353;
ld pi = asin(0.5) * (ld)6;

struct edge {
    int fr, to, fl, c;
    ll cost;
};

vector<edge> edges;
vector<vector<int>> g;
vector<ll> mn;
vector<int> fr, ver;
ll ANS = 0;

void add_r(int u, int v, int cp, ll cst) {
    g[u].push_back(edges.size());
    edges.push_back({ u, v, 0, cp, cst });
    g[v].push_back(edges.size());
    edges.push_back({ v, u, 0, 0, -cst });
}

void run_spfa(int s, int t) {
    ver.clear();
    ver.push_back(s);
    fill(all(fr), -1);
    fill(all(mn), MOD * MOD);
    mn[s] = 0;
    for (int i = 0; i < ver.size(); ++i) {
        int u = ver[i];
        for (int j : g[u]) {
            if (edges[j].fl < edges[j].c && mn[edges[j].to] > mn[u] + edges[j].cost) {
                mn[edges[j].to] = mn[u] + edges[j].cost;
                ver.push_back(edges[j].to);
                fr[edges[j].to] = j;
            }
        }
    }
    if (mn[t] != MOD * MOD) {
        ANS += mn[t];
        int nw = t;
        while (fr[nw] != -1) {
            ++edges[fr[nw]].fl;
            --edges[(fr[nw] ^ 1)].fl;
            nw = edges[fr[nw]].fr;
        }
    }
}

inline void solve(void) {
    int n, k; cin >> n >> k;
    vector<ll> L(n), R(n);
    for (int i = 0; i < n; ++i) {
        cin >> L[i] >> R[i];
    }
    g.resize(2 * n + 3);
    mn.resize(2 * n + 3);
    fr.resize(2 * n + 3);
    for (int i = 0; i < n; ++i) {
        add_r(2 * i, 2 * i + 1, 1, -inf);
    }
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            add_r(2 * i + 1, 2 * j, 1, abs(R[i] - L[j]));
        }
    }
    for (int i = 0; i < n; ++i) {
        add_r(2 * n + 1, 2 * i, 1, 0);
        add_r(2 * i + 1, 2 * n + 2, 1, 0);
    }
    add_r(2 * n, 2 * n + 1, k, 0);
    for (int i = 0; i < k; ++i) {
        run_spfa(2 * n, 2 * n + 2);
    }
    cout << ANS + (ll)n * inf;
}

int main(void) {
    //freopen("censored.in", "r", stdin);
    //freopen("censored.out", "w", stdout);
    cout << fixed << setprecision(20);
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int t = 1; srand(time(0)); //cin >> t;
    while (t--) solve();
    return 0;
}
