#include <bits/stdc++.h>
#define pii pair<int,int>
#define mpp make_pair
#define fi first
#define se second
#define ve vector
#define pb push_back
#define ll long long
#define ld long double
#define pll pair<ll,ll>
#define all(x) 			(x).begin(),(x).end()
#define sz(x) 			(int)((x).size())
template<typename T> inline bool chmin(T& a, T b) { return (a > b ? a = b, 1 : 0); }
template<typename T> inline bool chmax(T& a, T b) { return (a < b ? a = b, 1 : 0); }
const int iinf = 1e9; const ll inf = 1e18;
using namespace std;

struct edge { int to, r, cap, flow, cost; };
const int N = 1e5 + 100;
ve<edge> gr[N]; int s, t, nn;
inline void add(int v, int u, int c, int cost) {
    gr[v].pb({u, sz(gr[u]), c, 0, cost});
    gr[u].pb({v, sz(gr[v]) - 1, 0, 0, -cost});
}
ll d[N], pot[N];
pii p[N];
inline void bellman() {
    fill(d, d + nn, inf); d[s] = 0;
    while (1) {
        bool ch = 0;
        for (int i = 0; i < nn; ++i) {
            for (int id = 0; id < sz(gr[i]); ++id) {
                auto &[to, r, cap, flow, cost] = gr[i][id];
                if (cap - flow > 0 && chmin(d[to], d[i] + cost)) {
                    ch = 1; /*p[to] = {i, id};*/
                }
            }
        }
        if (!ch) break;
    }
}
int used[N];
inline void dijkstra() {
    fill(d, d + nn, inf); d[s] = 0;
	fill(used, used + nn, 0);

    for (int it = 0; it < nn; ++it) {
		int v = -1;
		for (int i = 0; i < nn; ++i) {
			if (!used[i] && (v == -1 || d[i] < d[v])) {
				v = i;
			}
		}
		if (d[v] == inf) break;
		used[v] = 1;
        for (int id = 0; id < sz(gr[v]); ++id) {
            auto &[to, r, cap, flow, w] = gr[v][id];
            if (cap - flow > 0 && d[to] > d[v] + w + pot[v] - pot[to]) {
                d[to] = d[v] + w + pot[v] - pot[to];
                p[to] = {v, id};
            }
        }
    }
}

ll answer[N];
inline pll mcf() {
    bellman(); for (int i = 0; i < nn; ++i) pot[i] = d[i];
    int flow = 0;
    ll cost = 0;

    while (1) {
        dijkstra();
        if (d[t] == inf) break;
        for (int i = 0; i < nn; ++i) pot[i] += d[i];

        int v = t, f = iinf;
        while (v != s) {
            auto &[u, id] = p[v];
            chmin(f, gr[u][id].cap - gr[u][id].flow);
            v = u;
        }
        v = t;
        for (int s = 1; s <= f; ++s) {
            chmin(answer[flow + s], cost + pot[t] * 1ll * s);
        }
        flow += f;
        cost += pot[t] * 1ll * f;

        while (v != s) {
            auto &[u, id] = p[v];
            gr[u][id].flow += f;
            gr[v][gr[u][id].r].flow -= f;
            v = u;
        }
    }
    return mpp(flow, cost);
}

inline void solve() {
    int n, k;
    cin >> n >> k;
    ve<pii> a(n);
    for (auto &[x, y] : a) cin >> x >> y;

    nn = 2 * n + 2; s = nn - 2, t = nn - 1;
    for (int i = 0; i < n; ++i) add(s, i, 1, 0), add(n + i, t, 1, 0);
    for (int i = 0; i < n; ++i) {
        auto &[li, ri] = a[i];
        for (int j = i + 1; j < n; ++j) {
            auto &[lj, rj] = a[j];
            add(i, n + j, 1, abs(ri - lj));
        }
    }

	fill(answer, answer + N, inf);
	mcf(); ll ans = inf;
	for (int i = n - k; i <= n; ++i) chmin(ans, answer[i]);
	cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int q = 1; // cin >> q;
    while (q--) solve();
    cerr << "time: " << clock() / CLOCKS_PER_SEC << endl;
}
