// Lifts.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <vector>
#include <algorithm>
#include <math.h>
using namespace std;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<vvi> vvvi;
typedef pair<int, int> pii;
typedef vector<pii> vp;
typedef vector<vp> vvp;
typedef vector<bool> vb;

vi visited, redirect, dir;
int calc_cost(vi& point, vi& dp, vp& lifts, int i, int n, vi& redirect, vi& visited)
{
    if (visited[i] != -1) return visited[i];
    int old = dp[point[i]];
    int best = INT32_MAX;
    for (int j = point[i] + 1; j < n; j++)
    {
        if (j == i)continue;
        if (point[j] == -1)
        {
            int cost = dp[j] + abs(lifts[point[i]].second - lifts[j].first);
            if (cost < best)
            {
                best = cost; redirect[point[i]] = j;
            }
        }
        else
        {
            int cost = abs(lifts[point[i]].second - lifts[j].first) + dp[j] + calc_cost(point, dp, lifts, j, n, redirect, visited);
            if (cost < best)
            {
                best = cost; redirect[point[i]] = j;
            }
        }
    }
    visited[i] = best - old;
    return best - old;
}

void match(vi& point, vi& dp, vp& lifts, int i, int n, int k)
{
    int cost = INT32_MAX;
    int ind = i;
    for (int j = i + 1; j < n + k; j++)
    {
        if (point[j] == -1)
        {
            int c = j < n? abs(lifts[i].second - lifts[j].first): 0;
            if(c < cost)
            {
                cost = c; ind = j;
            }
        }
        else
        {
            fill(visited.begin(), visited.end(), -1); fill(redirect.begin(), redirect.end(), -1);
            int c = calc_cost(point, dp, lifts, j, n, redirect, visited) + (j<n?abs(lifts[i].second - lifts[j].first):0);
            if (c < cost)
            {
                redirect[i] = j;
                cost = c; dir = redirect; ind = j;
            }
        }
    }
    dp[i] = dp[i + 1] + cost;
    int temp = point[ind];
    while (temp != -1)
    {
        int t = point[dir[temp]];
        point[dir[temp]] = temp;
        temp = t;
    }
    point[ind] = i;
}



int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int N, K; cin >> N >> K;
    vp lift(N);
    for (int i = 0; i < N; i++) cin >> lift[i].first >> lift[i].second;
    vi dp(N + K, 0);
    vi point(N + K, -1);
    visited.resize(N + K);
    redirect.resize(N + K);
    dir.resize(N + K);
    for (int i = N - 1; i >= 0; i--) match(point, dp, lift, i, N, K);
    cout << dp[0] << endl;
}
