// Lifts.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <vector>
#include <algorithm>
#include <math.h>
#include <time.h>
#include <random>
using namespace std;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<vvi> vvvi;
typedef pair<int, int> pii;
typedef vector<pii> vp;
typedef vector<vp> vvp;
typedef vector<bool> vb;

vi dir_cost, redirect, dir;
void calc_cost(vi& point, vi& dp, vp& lifts, int n)
{
    for (int i = point.size()-1; i >= 0; i--)
    {
        if (point[i] == -1)continue;
        int old = dp[point[i]];
        int best = INT32_MAX;
        for (int j = point[i] + 1; j < point.size(); j++)
        {
            if (j == i)continue;
            if (point[j] == -1)
            {
                int cost = dp[j] + (j<n?abs(lifts[point[i]].second - lifts[j].first):0);
                if (cost < best)
                {
                    best = cost; redirect[point[i]] = j;
                }
            }
            else
            {
                int cost = (j<n?abs(lifts[point[i]].second - lifts[j].first):0) + dp[j] + dir_cost[j];
                if (cost < best)
                {
                    best = cost; redirect[point[i]] = j;
                }
            }
        }
        dir_cost[i] = best - old;
    }
}

void match(vi& point, vi& dp, vp& lifts, int i, int n, int k)
{
    int cost = INT32_MAX;
    int ind = i;
    fill(dir_cost.begin(), dir_cost.end(), -1); fill(redirect.begin(), redirect.end(), -1);
    calc_cost(point, dp, lifts, n);
    for (int j = i + 1; j < n + k; j++)
    {
        if (point[j] == -1)
        {
            int c = j < n? abs(lifts[i].second - lifts[j].first): 0;
            if(c < cost)
            {
                cost = c; ind = j;
            }
        }
        else
        {
            int c = (j < n ? abs(lifts[i].second - lifts[j].first) : 0) + dir_cost[j];
            if (c < cost)
            {
                redirect[i] = j;
                cost = c; dir = redirect; ind = j;
            }
        }
    }
    dp[i] = dp[i + 1] + cost;
    int temp = point[ind];
    while (temp != -1 && point[dir[temp]] != temp)
    {
        int t = point[dir[temp]];
        point[dir[temp]] = temp;
        temp = t;
    }
    point[ind] = i;
}

void solve(int N, int K, vp& lift)
{
    vi dp(N + K, 0);
    vi point(N + K, -1);
    dir_cost.resize(N + K);
    redirect.resize(N + K);
    dir.resize(N + K);
    for (int i = N - 1; i >= 0; i--) 
        match(point, dp, lift, i, N, K);
    cout << dp[0] << endl;
}


int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int N, K; cin >> N >> K;
    vp lift(N);
    for (int i = 0; i < N; i++) cin >> lift[i].first >> lift[i].second;
    solve(N, K, lift);
}


/*int main()
{
    srand(time(NULL));
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int N = 3, K = 2;
    while (true)
    {
        vp lift(N);
        cout << "###" << endl;
        cout << N << " " << K << endl;
        for (int i = 0; i < N; i++) { lift[i].first = rand() % 10;  lift[i].second = rand() % 10;
        cout << lift[i].first << " " << lift[i].second << endl; }
        solve(N, K, lift);
    }
}*/
