#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef pair<ll, ll> pii;
typedef vector<ll> vi;
typedef vector<vi> vvi;
typedef vector<ll> vll;
typedef vector<vll> vvll;
typedef vector<bool> vb;
typedef vector<vb> vvb;
typedef vector<pii> vp;

const ll inf = 1e18 + 9;

// dp[i][j] min cost of first i queries when the last lift moved is j
// keep[i][j][k] location of lift k in dp[i][j]
// dp[i][j] = min(dp[i-1][x] + abs(keep[i-1][x][j]-l) + r-l)

vp queries;
vvi dp;
vvi last;
vvi lastj;

vector<vvi> keep;

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int n, k;
	cin >> n >> k;
	queries.resize(n + 1);
	dp.resize(n + 1, vi(k));
	last.resize(n + 1, vi(k));
	lastj.resize(n + 1, vi(k));

	keep.resize(n + 1, vvi(k, vi(k, -1)));

	for (int i = 0; i < n; i++) {
		cin >> queries[i + 1].first >> queries[i + 1].second;
	}

	for (int i = 1; i <= n; i++) {
		for (int j = 0; j < k; j++) {
			ll mincost = inf;
			ll minindex = -1;
			ll lastjd = -1;
			for (int x = 0; x < k; x++) {
				ll dist = abs(keep[i-1][x][j] - queries[i].first);
				if (keep[i-1][x][j] == -1)dist = 0;
				ll curr = dp[i - 1][x] + dist;
				if (curr < mincost) {
					mincost = curr;
					minindex = x;
					lastjd = dist;
				}
			}

			dp[i][j] = mincost;
			keep[i][j] = keep[i - 1][minindex];
			last[i][j] = keep[i][j][j];
			keep[i][j][j] = queries[i].second;
			lastj[i][j] = lastjd;

			mincost = inf;
			for (int a = 0; a < k; a++) {
				if (a == j)continue;
				for (int x = 1; x < i; x++) {
					if (x == 0)continue;
					ll dist = abs(keep[x][j][a] - queries[x].first);
					if (keep[x][j][a] == -1)dist = 0;
					ll dist2 = abs(last[x][j] - queries[i].first);
					if (last[x][j] == -1)dist2 = 0;

					//int dist3 = abs(keep[x][j][j] - queries[i].first);

					ll curr = dp[i][j] + dist + dist2 - lastj[x+1][j];
					if (curr < mincost) {
						mincost = curr;
						minindex = a;
					}
				}
			}

			if (mincost < dp[i][j]) {
				dp[i][j] = mincost;
				keep[i][j][minindex] = last[i][j];
				keep[i][j][j] = queries[i].second;
			}

		}
	}

	ll ans = inf;
	for (int j = 0; j < k; j++) {
		ans = min(ans, dp[n][j]);
	}
	cout << ans;

	return 0;
}