#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef pair<ll, ll> pii;
typedef vector<ll> vi;
typedef vector<vi> vvi;
typedef vector<ll> vll;
typedef vector<vll> vvll;
typedef vector<bool> vb;
typedef vector<vb> vvb;
typedef vector<pii> vp;

const ll inf = 1e18 + 9;

vp queries;
set<pii> keep;
map < pair<int, set<pii>>, ll> mp;


set<pii> update1(int locate, int amount, int q, set<pii> keep1) {
	
	keep1.erase(keep1.find({ locate,amount }));
	if (amount - 1 > 0)keep1.insert({ locate,amount - 1 });

	auto it = keep1.lower_bound({ queries[q].second,-1 });
	if (it!=keep1.end() && ((pii)*it).first == queries[q].second){
		int lasta = ((pii)*it).second;
		keep1.erase(it);
		keep1.insert({ queries[q].second , lasta + 1 });
	}
	else {
		keep1.insert({ queries[q].second , 1 });
	}
	return keep1;
}


void update2(int locate, int amount, int q) {

	auto it = keep.lower_bound({ queries[q].second,-1 });
	pii curr = *it;
	if (curr.second == 1)keep.erase(it);
	else
	{
		keep.erase(it);
		keep.insert({ curr.first,curr.second - 1 });
	}

	it = keep.lower_bound({ locate,-1 });
	if (it != keep.end() && ((pii)*it).first == locate) {
		int lasta = ((pii)*it).second;
		keep.erase(it);
		keep.insert({ locate , lasta + 1 });
	}
	else {
		keep.insert({ locate , 1 });
	}
}


ll bfs(int k, int n) {
	
	priority_queue<pair<int, set<pii>>, vector<pair<int, set<pii>>>, greater<pair<int, set<pii>>>> pq;
	//queue <pair<int, set<pii>>> qu;
	set<pii>start;
	start.insert({ -1,k });
	mp[{1, start}] = 0;
	pq.push({ 1,start });

	ll ans = inf;
	while (!pq.empty())
	{
		int q = pq.top().first;
		set<pii> keep = pq.top().second;
		pq.pop();
		if (q == n+1) {
			ll an = mp[{q, keep}];
			ans = min(ans, an);
			continue;
		}

		auto it = keep.begin();
		vi locate(keep.size());
		vi amount(keep.size());
		for (int i = 0; i < keep.size(); i++) {
			pii curr = *it;
			locate[i] = curr.first;
			amount[i] = curr.second;
			it++;
		}

		for (int i = 0; i < locate.size(); i++) {
			ll dist = abs(locate[i] - queries[q].first);
			if (locate[i] == -1) dist = 0;

			set<pii> next = update1(locate[i], amount[i], q, keep);
			ll curr = mp[{q, keep}] + dist;
			if (mp.find({ q+1,next }) == mp.end() || mp[{ q+1, next }] > curr){
				pq.push({ q + 1,next });
				mp[{q+1, next}] = curr;
			}

		}

	}
	return ans;
}



ll cost(int k, int q, ll c) {
	if (mp.find({ q,keep }) != mp.end() && mp[{ q, keep }]< c ) {
		return inf;
	}
	mp[{q, keep}] = c;

	if (q == queries.size())return c;
	ll ans = inf;

	auto it = keep.begin();
	vi locate(keep.size());
	vi amount(keep.size());
	for (int i = 0; i < keep.size(); i++) {
		pii curr = *it;
		locate[i] = curr.first;
		amount[i] = curr.second;
		it++;
	}

	for (int i = 0; i < locate.size(); i++) {
		ll dist = abs(locate[i] - queries[q].first);
		if (locate[i] == -1) dist = 0;
		
		//update1(locate[i], amount[i], q);
		ll m = cost(k, q + 1, c + dist);

		update2(locate[i], amount[i], q);

		ans = min(ans, m);
	}

	return ans;
}


int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int n, k;
	cin >> n >> k;
	queries.resize(n + 1);
	vi locate(k, -1);
	for (int i = 0; i < n; i++) {
		cin >> queries[i + 1].first >> queries[i + 1].second;
	}

	keep.insert({ -1,k });

	ll ans = bfs(k,n);

	cout << ans;

	return 0;
}