#include <iostream>
#include <fstream>
#include <bitset>
#include <vector>
#include <queue>

using namespace std;

ifstream fin("test.in");
ofstream fout("test.out");
#define int long long
const long long inf = (1LL << 60);
const int maxN = 10005;
int n, p;
long long sp[maxN], ans;
pair <int, int> v[maxN];
vector <int> lant[30];

int modul(int x)
{
    if(x < 0)
        x = -x;
    return x;
}

int cost(int x, int y)
{
    return modul(v[x].second - v[y].first);
}

long long merge_cost(int x, int y)
{
    long long curr_cost = 0;
    vector <int> aux;
    int i = 0, j = 0;
    while(i < lant[x].size() && j < lant[y].size())
    {
        if(lant[x][i] < lant[y][j])
        {
            aux.push_back(lant[x][i]);
            i++;
        }
        else
        {
            aux.push_back(lant[y][j]);
            j++;
        }
    }
    while(i < lant[x].size())
    {
        aux.push_back(lant[x][i]);
        i++;
    }
    while(j < lant[y].size())
    {
        aux.push_back(lant[y][j]);
        j++;
    }
    for(i - 1; i < aux.size(); i++)
        curr_cost += cost(aux[i - 1], aux[i]);
    return curr_cost;
}

void merge_lant(int x, int y)
{
    vector <int> aux;
    int i = 0, j = 0;
    while(i < lant[x].size() && j < lant[y].size())
    {
        if(lant[x][i] < lant[y][j])
        {
            aux.push_back(lant[x][i]);
            i++;
        }
        else
        {
            aux.push_back(lant[y][j]);
            j++;
        }
    }
    while(i < lant[x].size())
    {
        aux.push_back(lant[x][i]);
        i++;
    }
    while(j < lant[y].size())
    {
        aux.push_back(lant[y][j]);
        j++;
    }
    lant[y].clear();
    lant[x] = aux;
}

signed main()
{
    cin >> n >> p;
    for(int i = 1; i <= n; i++)
        cin >> v[i].first >> v[i].second;
    for(int i = 1; i <= p; i++)
        lant[i].push_back(i);
    for(int i = p + 1; i <= n; i++)
    {
        long long best_cost = inf, curr_cost, best_add;
        bool best_is_merge = 0;
        pair <int, int> best_merge;
        for(int j = 1; j <= p; j++)
        {
            curr_cost = cost(lant[j].back(), i);
            if(curr_cost < best_cost)
            {
                best_cost = curr_cost;
                best_add = j;
            }
        }
        for(int j = 1; j <= p; j++)
        {
            for(int k = j + 1; k <= p; k++)
            {
                curr_cost = merge_cost(j, k);
                if(curr_cost < best_cost)
                {
                    best_is_merge = 1;
                    best_cost = curr_cost;
                    best_merge = {j, k};
                }
            }
        }
        //cout << i;
        if(best_is_merge)
        {
            int j = best_merge.first, k = best_merge.second;
            merge_lant(j, k);
            lant[k].push_back(i);
        }
        else
            lant[best_add].push_back(i);
        ans += best_cost;
    }
    cout << ans;
    return 0;
}
