#include <bits/stdc++.h>

using namespace std;
using ll = long long;
const ll INF = 1e18;
struct edge {
    int from, to;
    ll cap, cost;
};
const int N = 10000 + 30 + 5;
vector <edge> edges;
vector <int> g[N];
int s, t;
ll d[N];
bool inq[N];
int from[N];
void add_edge(int u, int v, int w, int c) {
    g[u].push_back(edges.size());
    edges.push_back({u, v, w, c});
    g[v].push_back(edges.size());
    edges.push_back({v, u, 0, -c});
}
bool bellman() {
    queue <int> q;
    fill(d, d + t + 1, INF);
    fill(from, from + t + 1, -1);
    q.push(s);
    fill(inq, inq + t + 1, false);
    d[s] = 0;
    while(!q.empty()) {
        int u = q.front();
        q.pop();
        inq[u] = false;
        for(int id : g[u]) {
            auto [uu, v, cap, cost] = edges[id];
            if(cap && d[u] + cost < d[v]) {
                d[v] = d[u] + cost;
                if(!inq[v]) {
                    inq[v] = true;
                    q.push(v);
                }
                from[v] = id;
            }
        }
    }
    return d[t] != INF;
}
pair <int, ll> flow() {
    ll max_flow = 0, min_cost = 0;
    while(bellman()) {
        ll min_flow = INF;
        for(int i = from[t]; i != -1; i = from[edges[i].from])
            min_flow = min(min_flow, edges[i].cap);
        for(int i = from[t]; i != -1; i = from[edges[i].from]) {
            edges[i].cap -= min_flow;
            edges[i^1].cap += min_flow;
            min_cost += min_flow * edges[i].cost;
        }
        max_flow += min_flow;
    }
    return {max_flow, min_cost};
}
int l[N], r[N];

int main()
{
    int n, k;
    cin >> n >> k;
    for(int i = 1; i <= n; i++) {
        cin >> l[i] >> r[i];
    }
    /// label nodes
    /// source: 0
    /// bottleneck: 1
    /// queries IN: 2->n+1
    /// queries OUT: n+2->2n+1
    /// sink: 2n+2
    s = 0, t = 2 * n + 2;
    add_edge(s, 1, n - k, 0);
    for(int i = 2; i <= n+1; i++)
        add_edge(1, i, 1, 0);
    for(int i = 2; i <= n + 1; i++)
        for(int j = i + n + 1; j <= 2 * n + 1; j++)
            add_edge(i, j, 1, abs(r[i-1]-l[j-n-1]));
    for(int i = n+2; i <= 2 * n + 1; i++)
        add_edge(i, t, 1, 0);
    auto res = flow();
    assert(res.first == n - k);
    cout << res.second << "\n";
    return 0;
}
