#include <bits/stdc++.h>

using namespace std;
unsigned seed = chrono :: system_clock :: now().time_since_epoch().count();
mt19937 rng(seed);
using ll = long long;
const ll INF = 1e18;
struct edge {
    int from, to;
    ll cap, cost;
};
const int NN = 1250;
const int N = 2 * NN + 5;
edge edges[N + NN * NN / 2 + 50];
int sz = 0;
vector <int> g[N];
int s, t;
ll d[N], dist[N];
bool inq[N];
int from[N];
void add_edge(int u, int v, int w, int c) {
    g[u].push_back(sz);
    edges[sz++] = {u, v, w, c};
    g[v].push_back(sz);
    edges[sz++] = {v, u, 0, -c};
}
void bellman() {
    /*queue <int> q;
    fill(d, d + t + 1, INF);
    q.push(s);
    fill(inq, inq + t + 1, false);
    d[s] = 0;
    while(!q.empty()) {
        int u = q.front();
        q.pop();
        inq[u] = false;
        for(int id : g[u]) {
            auto [uu, v, cap, cost] = edges[id];
            if(cap && d[u] + cost < d[v]) {
                d[v] = d[u] + cost;
                if(!inq[v]) {
                    inq[v] = true;
                    q.push(v);
                }
            }
        }
    }*/
}
struct heapn {ll d; int u;
    friend bool operator <(const heapn& a, const heapn& b) { return a.d > b.d; }
};
bool dijkstra() {
    priority_queue <heapn> pq;
    fill(dist, dist + t + 1, INF);
    fill(from, from + t + 1, -1);
    fill(inq, inq + t + 1, false);
    pq.push({0, s});
    dist[s] = 0;
    while(!pq.empty()) {
        auto [dd, u] = pq.top();
        pq.pop();
        if(inq[u]) continue;
        inq[u] = true;
        for(int id : g[u]) {
            auto [uu, v, cap, cost] = edges[id];
            if(cap && dist[u] + d[u] - d[v] + cost < dist[v]) {
                dist[v] = dist[u] + d[u] - d[v] + cost;
                from[v] = id;
                pq.push({dist[v], v});
            }
        }
    }
    for(int i = 0; i <= t; i++)
        d[i] = min(INF, d[i] + dist[i]);
    return dist[t] != INF;
}
/*
3 2
5 20
8 100
2 80
*/
pair <int, ll> flow() {
    ll max_flow = 0, min_cost = 0;
    bellman();
    while(dijkstra()) {
        ll min_flow = INF;
        for(int i = from[t]; i != -1; i = from[edges[i].from])
            min_flow = min(min_flow, edges[i].cap);
        for(int i = from[t]; i != -1; i = from[edges[i].from]) {
            edges[i].cap -= min_flow;
            edges[i^1].cap += min_flow;
            min_cost += min_flow * edges[i].cost;
        }
        max_flow += min_flow;
    }
    return {max_flow, min_cost};
}
int l[N], r[N];
const int bulan = N;
const int P = 100;
int _norm(ll x) { return x < 0 ? x + P : x; }

int main()
{
    int n, k;
    cin >> n >> k;
    for(int i = 1; i <= n; i++) {
        cin >> l[i] >> r[i];
    }
    /// label nodes
    /// source: 0
    /// bottleneck: 1
    /// queries IN: 2->n+1
    /// queries OUT: n+2->2n+1
    /// positions:
    /// sink: 2n+2
    s = 0, t = 2 * n + 2;
    add_edge(s, 1, n - k, 0);
    for(int i = 2; i <= n+1; i++)
        add_edge(1, i, 1, 0);
    fill(d, d + t + 1, INF);
    fill(d, d + n + 2, 0);
    for(int i = 2; i <= n + 1; i++)
        for(int j = i + n + 1; j <= 2 * n + 1; j++) if(n <= 600 || _norm(rng() % 100) > 20) {
            add_edge(i, j, 1, abs(r[i-1]-l[j-n-1]));
            d[j] = min(d[j], llabs(r[i-1]-l[j-n-1]));
        }
    for(int i = n+2; i <= 2 * n + 1; i++) {
        add_edge(i, t, 1, 0);
        d[t] = min(d[t], d[i]);
    }
    auto res = flow();
    assert(res.first == n - k);
    cout << res.second << "\n";
    return 0;
}
