#include <bits/stdc++.h>
#define dbg(x) cerr << #x << ' ' << x << '\n'

using namespace std;

int moves[100000];

random_device rd;  //Will be used to obtain a seed for the random number engine
mt19937 gen(rd()); //Standard mersenne_twister_engine seeded with rd()
uniform_real_distribution<> dis(0.0, 1.0);

void simulate(double p, int n, int l, int r, bool rl, bool rr, int k) {
    // dbg(p);
    // dbg(l); dbg(r);
    // dbg(rl); dbg(rr);

    if (l == n && r == n && rl == 0 && rr == 0) {
        // dbg(k);
        moves[k]++;
        return;
    }
    
    double x = dis(gen);
    if (rl == true || rr == true) {
        if (x < p) { // the next move will apply to left
            if (rl == true)
                simulate(p, n, l, r, 0, 0, k + 1);
            else simulate(p, n, max(0, l - 1), r, 0, 1, k + 1);
        } else { // the next move will apply to right
            if (rr == true)
                simulate(p, n, l, r, 0, 0, k + 1);
            else simulate(p, n, l, max(0, r - 1), 1, 0, k + 1);
        }
    } else {
        if (l == r && x < p)
            simulate(p, n, l + 1, r, 0, 0, k + 1);
        else if (l == r && x >= p)
            simulate(p, n, l, r + 1, 0, 0, k + 1);
        else {
            assert(l != r);
            int dir; // 1 - left, 2 - right
            if (l == n) dir = 2;
            else if (r == n) dir = 1;
            else if (p >= 1 - p) dir = 1;
            else dir = 2;

            if (dir == 1) {
                if (x < p) simulate(p, n, l + 1, r, 0, 0, k + 1);
                else simulate(p, n, l, r, 0, 1, k + 1);
            } else {
                if (x >= p) simulate(p, n, l, r + 1, 0, 0, k + 1);
                else simulate(p, n, l, r, 1, 0, k + 1);
            }
        }
    }
}

int main() {
    double p;
    int l, r, n;
    cin >> p >> n >> l >> r;
    
    for (int i = 0; i <= 1000000; i++)
        simulate(p, n, l, r, 0, 0, 0);
    int sum = 0;

    double ans = 0;
    for (int i = 0; i < 100000; i++)
        sum += moves[i];

    for (int i = 0; i < 100000; i++) {
        ans += (double)moves[i] / sum * (double) i;
        // cerr << moves[i] << '\n';
    }
    cout << ans << '\n';
    return 0;
}
