#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cassert>

using ll = long long;

int const nmax = 5000;
ll const inf = 1000000000000000000;

int v[5 + nmax], active[5 + nmax];

ll solve(int n, int sp, int coef) {
  std::fill(active, active + n + 1, 0);
  ll result = 0;
  ll acc = 0;
  for(int i = 1; i <= sp; i++)
    acc += v[i];
  result = acc * coef;
  
  for(int i = 1;i <= sp; i++)
    active[i] = 1;
  
  ll side1 = 0, side2 = 0;
  for(int i = 1; i <= std::min(sp, n - sp); i++) {
    ll acc = side2, acc2 = side1;
    int pass = (i), pass2 = (i);
    ll sbest = inf, sbest2 = inf;
    int posbest = 0, posbest2 = 0;

    for(int j = sp; 1 <= j; j--) {
      if(active[j] == 1) {
        if(acc + (pass - coef) * v[j] < sbest) {
          sbest = acc + (pass - coef) * v[j];
          posbest = j;
        }
        acc += v[j];
        pass++;
      }
    }
        
    for(int j = sp + 1; j <= n; j++) {
      if(active[j] == 0) {
        if(acc2 + (pass2 + coef) * v[j] < sbest2) {
          sbest2 = acc2 + (pass2 + coef) * v[j];
          posbest2 = j;
        }
        acc2 += v[j];
        pass2++;
      }
    }
    if(sbest + sbest2 < 0) {
      result += sbest + sbest2;
      active[posbest] = 0;
      active[posbest2] = 0;
      side1 += v[posbest];
      side2 += v[posbest2];
    } else
      break;
  }
  return result;
}

int main() {
  std::ios::sync_with_stdio(0);
  std::cin.tie(0);

  int n, q, coef;
  std::cin >> n >> q >> coef;
  
  for(int i = 1;i <= n; i++)
    std::cin >> v[i];

  for(int i = 1; i <= q; i++) {
    int sp;
    std::cin >> sp;
    std::cout << solve(n, sp, coef) << '\n';
  }
  return 0;
}
