#include <bits/stdc++.h>

using namespace std;

#define int long long
const int NMAX = 1e6 + 7;
int sp[NMAX], v[NMAX];
int N, A, Q;
int split;

struct PrefElem {
    int poz;
    int get_value() const {
        return sp[split] - sp[poz] + v[poz] * (split + 1 - poz) - v[poz] * A;
    }
    bool operator<(const PrefElem &oth) const {
        if(get_value() == oth.get_value()) return poz < oth.poz;
        return get_value() < oth.get_value();
    }
};

struct SuffElem {
    int poz;
    int get_value() const {
        return sp[poz - 1] - sp[split] + v[poz] * (poz - split) + v[poz] * A;
    }
    bool operator<(const SuffElem& oth) const {
        if(get_value() == oth.get_value()) return poz < oth.poz;
        return get_value() < oth.get_value();
    }
};

vector<PrefElem> pref;
vector<SuffElem> suff;

int64_t comb() {
    int64_t cnt_sum = sp[split] * A;
    int64_t best_sum = cnt_sum;

    auto it_pr = pref.begin();
    auto it_sf = suff.begin();

    while(it_pr != pref.end() && it_sf != suff.end()) {
        cnt_sum += it_pr->get_value() + it_sf->get_value();

    // cerr << it_pr->get_value() << endl;
    // cerr << it_sf->get_value() << endl;
        
        best_sum = min(best_sum, cnt_sum);
        it_pr++; it_sf++;
    }

    return best_sum;
}

int prec[NMAX];
int32_t main() {
    cin >> N >> Q >> A;
    for(int i = 1; i <= N; i++) {
        cin >> v[i]; sp[i] = sp[i - 1] + v[i];
    }

    for(int i = 1; i <= Q; i++) {
        int R; cin >> R;

        suff.clear(); pref.clear();

        split = R;
        for(int j = 1; j <= split; j++) {
            pref.push_back({j});
        } sort(pref.begin(), pref.end());
        for(int j = split + 1; j <= N; j++) {
            suff.push_back({j});
        } sort(suff.begin(), suff.end());

        cout << comb() << '\n';
    }
}
