#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>

using namespace std;

#define int long long
const int NMAX = 1e6 + 7;
int sp[NMAX], v[NMAX];
int N, A, Q;
int split;

struct PrefElem {
    int poz;
    PrefElem(int x) {poz =  x;}
    int get_value() const {
        return sp[split] - sp[poz] + v[poz] * (split + 1 - poz) - v[poz] * A;
    }
    bool operator<(const PrefElem &oth) const {
        if(get_value() == oth.get_value()) return poz < oth.poz;
        return get_value() < oth.get_value();
    }
};

struct SuffElem {
    int poz;
    SuffElem(int x) {poz = x;}
    int get_value() const {
        return sp[poz - 1] - sp[split] + v[poz] * (poz - split) + v[poz] * A;
    }
    bool operator<(const SuffElem& oth) const {
        if(get_value() == oth.get_value()) return poz < oth.poz;
        return get_value() < oth.get_value();
    }
};

vector<int> pref;
vector<int> suff;

int64_t comb() {
    int64_t cnt_sum = sp[split] * A;
    int64_t best_sum = cnt_sum;

    for(int i = 0; i < pref.size() && i < suff.size(); i++) {
        cnt_sum += pref[i] + suff[i];
        best_sum = min(best_sum, cnt_sum);
    }

    return best_sum;
}

int prec[NMAX];
int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    cin >> N >> Q >> A;
    for(int i = 1; i <= N; i++) {
        cin >> v[i]; sp[i] = sp[i - 1] + v[i];
    }

    for(int i = 1; i <= Q; i++) {
        int R; cin >> R;
        if(prec[R] != 0) {
            cout << prec[R] << '\n';
            continue;
        }

        suff.clear(); pref.clear();

        split = R;
        for(int j = 1; j <= split; j++) {
            pref.push_back(PrefElem(j).get_value());
        } sort(pref.begin(), pref.end());
        for(int j = split + 1; j <= N; j++) {
            suff.push_back(SuffElem(j).get_value());
        } sort(suff.begin(), suff.end());
        
        prec[R] = comb();
        cout << prec[R] << '\n';
    }
}
