#include <bits/stdc++.h>

using namespace std;

bool withp(double p) {
    double i = 1. * rand() / RAND_MAX; 
    return i < p;
}

int simul(int l, int r, int n, double p) {
    double wl = 0, wr = 0;
    int steps = 0;

    while(true) {
        steps += 1;
        if(l == n && r == n && wl == 0 && wr == 0) return steps - 1;

        if(wl > 0 && wr > 0) {
            if(withp(p)) wl -= 1;
            else wr -= 1;
            continue;
        }

        if(wl > 0 && wr == 0) {
            if(withp(p)) wl -= 1;
            else r = max(r - 1, 0);
            continue;
        }

        if(wl == 0 && wr > 0) {
            if(withp(p)) l =max(l -1 , 0);
            else wr -= 1;
            continue;
        }

        if(l > r) {
            if(withp(p)) wl +=1 ;
            else r += 1;
            continue;
        }

        if(l < r) {
            if(withp(p)) l += 1;
            else wr += 1;
            continue;
        }

        if(l == r) {
            if(withp(p)) l += 1;
            else r += 1;
            continue;
        }
    }

}

double crazy(double n, double p) {
    // cerr << "called" << n << " " << p << endl;
    return 2 * n / p - 2 * n + 2;
}

double crazier(double n, double p, double dif) {
    return (2 * dif * n - dif * (dif - 1)) / p - 2 * dif * n + dif * (dif + 1); 
}

double solve(int n, int l, int r, double p) {
    double steps = 0;
    if(l < r) {
        steps += crazier(r, p, r - l);
        l = r;
    }
    if(l > r) {
        steps += crazier(l, 1 - p, l - r);
        r = l;
    }

    while(l < n) {
        steps += 1;

        steps += p * crazier(l + 1, 1 - p, 1);
        steps += (1 - p) * crazier(r + 1, p, 1);

        l += 1; r += 1;
    }

    return steps;
}

int main() {
    double p; int n, l, r; cin >> p >> n >> l >> r;
    /*
    double avg = 0; int maxrep = 1e7;
    for(int rep = 0; rep < maxrep; rep++) {
        if(rep % (1 << 20) == 0) cout << rep << endl;
        avg += simul(l, r, n, p);
    }
    avg /= (double)maxrep;
    cout << "AVG: " << avg << endl;
    */

    cout << fixed << setprecision(17) << solve(n, l, r, p) << endl;
}
