#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
#define int long long
const int N = 2 * 777;
const ll INF = (ll) 1e18 + 7;
int fldim;
int fls;
int fld;
int par[N];
int flcap[N][N];
int flcost[N][N];
bool inq[N];
ll minflcost[N];
queue<int> q;
vector<pair<int, int>> path;
int flow;
ll flowflcost;
void flinit(int dim, int s, int d)
{
    fldim = dim;
    fls = s;
    fld = d;
    flow = 0;
    flowflcost = 0;
    assert(1 <= fls && fls <= fldim);
    for (int i = 1; i <= fldim; i++)
    {
        for (int j = 1; j <= fldim; j++)
        {
            flcap[i][j] = 0;
        }
    }
}
void fladdedge(int a, int b, int c, int d)
{
    assert(1 <= a && a <= fldim);
    assert(1 <= b && b <= fldim);
    flcap[a][b] = c;
    flcost[a][b] = d;
    flcost[b][a] = -d;
}
void flowstep()
{
    for (int i = 1; i <= fldim; i++)
    {
        minflcost[i] = INF;
        par[i] = -1;
        inq[i] = 0;
    }
    assert(q.empty());
    q.push(fls);
    minflcost[fls] = 0;
    inq[fls] = 1;
    while (!q.empty())
    {
        int a = q.front();
        q.pop();
        assert(inq[a]);
        inq[a] = 0;
        for (int b = 1; b <= fldim; b++)
        {
            if (flcap[a][b])
            {
                ll upd = minflcost[a] + flcost[a][b];
                if (upd < minflcost[b])
                {
                    minflcost[b] = upd;
                    if (inq[b] == 0)
                    {
                        inq[b] = 1;
                        q.push(b);
                    }
                    par[b] = a;
                }
            }
        }
    }
    if (par[fld] == -1)
    {
        return;
    }
    path.clear();
    int v = fld;
    while (v != fls)
    {
        path.push_back({par[v], v});
        v = par[v];
    }
    reverse(path.begin(), path.end());
    int minflcap = (int) 1e9 + 7;
    for (auto &it : path)
    {
        minflcap = min(minflcap, flcap[it.first][it.second]);
    }
    assert(minflcap > 0);
    ll sum = 0;
    for (auto &it : path)
    {
        flcap[it.first][it.second] -= minflcap;
        flcap[it.second][it.first] += minflcap;
        sum += flcost[it.first][it.second];
    }
    flow += minflcap;
    assert(sum == minflcost[fld]);
    flowflcost += sum * minflcap;
}
int n;
int k;
int in[N];
int out[N];
int cost[N][N];
signed main()
{
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    freopen ("input.txt", "r", stdin);
    if (0)
    {
        flinit(4, 1, 2);
        fladdedge(1, 3, 4, 10);
        fladdedge(3, 2, 2, 20);
        flowstep();
        cout << flow << " " << flowflcost << "\n";
        return 0;
    }
    int cmax = (int) 1e9 + 7;
    cin >> n >> k;
    for (int i = 1; i <= n; i++)
    {
        cin >> in[i] >> out[i];
    }
    if (n == k)
    {
        cout << "0\n";
        return 0;
    }
    for (int i = 1; i <= n; i++)
    {
        for (int j = i + 1; j <= n; j++)
        {
            cost[i][j] = abs(in[j] - out[i]);
            cmax = max(cmax, cost[i][j]);
        }
    }
    int s = 2 * n + 1;
    int d = 2 * n + 2;
    flinit(2 * n + 2, s, d);
    for (int i = 1; i <= n; i++)
    {
        fladdedge(2 * i - 1, 2 * i, (int) 1e9, 0);
        fladdedge(s, 2 * i, 1, 0);
        fladdedge(2 * i - 1, d, 1, 0);
    }
   // cout << cost[1][2] << "\n";
    for (int i = 1; i <= n; i++)
    {
        for (int j = i + 1; j <= n; j++)
        {
            ///fladdedge(2 * i, 2 * j - 1, 1, cmax - cost[i][j]);
            fladdedge(2 * i, 2 * j - 1, 1, cost[i][j]);
        }
    }
    for (int step = 1; step < n; step++)
    {
        flowstep();
        assert(flow == step);
        if (n - step <= k)
        {
            cout << flowflcost << "\n";
            return 0;
            cout << " = " << flowflcost << "\n";
        }
    }
    assert(0);
    return 0;
}
