#include <bits/stdc++.h>
using namespace std;

mt19937 gen(time(0));

int n, k;
vector<pair<int, int>> l;
vector<int> lift;
long long sol, bestSol;

set<int> lifts[30];

int getCost(int i, int j){
	if(i==0) return 0;
	return abs(l[i].second-l[j].first);
}
void rem(int i, int lf){
	auto it=lifts[lf].lower_bound(i);
	if(next(it)==lifts[lf].end()){
		int pr=*prev(it);
		sol-=getCost(pr, i);
	}
	else{
		int pr=*prev(it);
		int nx=*next(it);
		sol-=getCost(pr, i);
		sol-=getCost(i, nx);
		sol+=getCost(pr, nx);
	}
	lifts[lf].erase(i);
}

void add(int i, int lf){
	auto it=lifts[lf].lower_bound(i);
	if(it==lifts[lf].end()){
		int pr=*prev(it);
		sol+=getCost(pr, i);
	}
	else{
		int pr=*prev(it);
		int nx=*it;
		sol-=getCost(pr, nx);
		sol+=getCost(pr, i);
		sol+=getCost(i, nx);
	}
	lifts[lf].insert(i);
}

bool improve(int i, int lf){
	if(lf==lift[i]) return 0;
	int prevSol=sol;
	rem(i, lift[i]);
	add(i, lf);
	if(sol<prevSol){
		lift[i]=lf;
		bestSol=min(sol, bestSol);
		return 1;
	}
	rem(i, lf);
	add(i, lift[i]);
	return 0;
}


int main(){
	srand(time(0));
	int start=clock();
	cin>>n>>k;
	l.resize(n+1);
	lift.resize(n+1);
	for(int i=1;i<=n;++i) cin>>l[i].first>>l[i].second;
	bestSol=1LL<<60;
	int contor=1;
	//int nr1=5;
	//while(nr1--){
	while((clock()-start)<2.48*CLOCKS_PER_SEC){
		for(int i=0;i<k;++i) lifts[i].clear(), lifts[i].insert(0);
		for(int i=1;i<=n;++i){
			vector<pair<int, int>> costs;
			for(int j=0;j<k;++j){
				int cost=getCost(*(prev(lifts[j].end())), i);
				costs.push_back({cost, j});
			}
			sort(costs.begin(), costs.end());
			int bnd=min(k, contor++);
			if(contor==k) contor=1;
			int lf=costs[gen()%bnd].second;
			sol+=getCost(*(prev(lifts[lf].end())), i);
			lifts[lf].insert(i);
			lift[i]=lf;
		}
		bestSol=min(sol, bestSol);
		//int nr2=10000;
		//while(nr2--){
		vector<int> eye(n);
		for(int i=0;i<n;++i) eye[i]=i+1;
		int ok=1;
		while(ok){
			random_shuffle(eye.begin(), eye.end());
			ok--;
			bool ok2=0;
			for(auto i:eye){
				for(int j=0;j<k;++j){
					ok2|improve(i, j);
				}
			}
		}
	}
	cout<<bestSol<<"\n";
	return 0;
}


