#include <bits/stdc++.h>

using namespace std;

typedef long long LL;
constexpr int NMAX = 1250;
constexpr LL INF = 1LL * 1e13;

int N, K;

LL cost[NMAX][NMAX];
int L[NMAX];
int R[NMAX];

int cap[NMAX][NMAX];
int flow[NMAX][NMAX];

int Source, Dest;
vector <int> G[NMAX];

LL modul (LL x) {
    if (x < 0) return -x;

    return x;
}

void Add_Edge (int x, int y, LL val, int c) {
    cost[x][y] = val;
    cost[y][x] = -val;

    G[x].push_back(y);
    G[y].push_back(x);

    cap[x][y] = c;
}

LL PI[NMAX];
LL n_PI[NMAX];
LL dist[NMAX];
int lg[NMAX];
bool used[NMAX];
int Dad[NMAX];

LL New_Weight (int x, int y) {
    return cost[x][y] + PI[x] - PI[y];
}

void BellMan_Ford (int S, int D) {
    queue <int> Q;
    for (int i = 0; i <= 2*N+2; ++ i ) {
        PI[i] = INF * (2LL * N + 2LL);
        lg[i] = 0;
        used[i] = false;
    }

    PI[0] = 0;
    lg[0] = 1;
    used[0] = true;
    Q.push(S);

    while (!Q.empty()) {
        int nod = Q.front();
        Q.pop();
        used[nod] = false;

        for (auto it : G[nod]) {
            if (cap[nod][it] != flow[nod][it] && PI[it] > PI[nod] + cost[nod][it]) {
                PI[it] = PI[nod] + cost[nod][it];
                lg[it] = lg[nod] + 1;

                if (lg[it] == N) continue;

                if (!used[it]) {
                    used[it] = true;
                    Q.push(it);
                }
            }
        }
    }
}

bool Dijkstra (int S, int D) {
    priority_queue <pair <long long, int> , vector <pair <long long, int> >, greater<pair <long long, int> > > H;

    for (int i = 0; i <= 2 * N + 2; ++ i ) {
        dist[i] = INF * (2LL*N + 2LL);
        Dad[i] = -1;
    }

    Dad[S] = 0;
    dist[S] = 0;
    memset(used, 0, sizeof(used));
    H.push({0, S});

    while (!H.empty()) {
        pair <long long, int>  x = H.top();
        H.pop();

        if (used[x.second]) continue;

        used[x.second] = true;
        int nod = x.second;

        for (auto it : G[nod]) {
            if (cap[nod][it] != flow[nod][it] && dist[it] > dist[nod] + New_Weight(nod, it)) {
                dist[it] = dist[nod] + New_Weight(nod, it);
                Dad[it] = nod;
                n_PI[it] = n_PI[nod] + cost[nod][it];

                H.push({dist[it], it});
            }
        }
    }

    for (int i = 0; i <= 2 * N + 2; ++ i )
        n_PI[i] = PI[i];

    return used[D];
}

void Read () {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> N >> K;

    for (int i = 1; i <= N; ++ i ) {
        cin >> L[i] >> R[i];
    }
}

void Precompute () {
    Source = 0;
    Add_Edge(0, 2*N+1, 0, K);

    for (int i = 1; i <= N; ++ i )
        Add_Edge(2*N+1, i, 0, 1);

    for (int i = 1; i <= N; ++ i ) {
        Add_Edge(i, i+N, -INF, 1);
        for (int j = i+1; j <= N; ++ j )
            Add_Edge(i+N, j, modul(R[i] - L[j]), 1);
    }

    for (int i = 1; i <= N; ++ i )
        Add_Edge(i+N, 2*N+2, 0, 1);
}

void Solve () {
    BellMan_Ford(0, 2*N+2);
    LL ans = 0;

    while (Dijkstra(0, 2*N+2)) {
        LL c = 0;
        int cnt_flow = (cap[Dad[2*N+2]][2*N+2] - flow[Dad[2*N+2]][2*N+2]);

        for (int i = 2*N+2; i != 0; i = Dad[i])
            cnt_flow = min(cnt_flow, cap[Dad[i]][i] - flow[Dad[i]][i]);

        for (int i = 2*N+2; i != 0; i = Dad[i]) {
            ans += 1LL * cnt_flow * cost[Dad[i]][i];
            flow[Dad[i]][i] += cnt_flow;
            flow[i][Dad[i]] -= cnt_flow;
        }
    }

    cout << ans + 1LL * N * INF << '\n';
}

int main () {
    Read();
    Precompute();
    Solve();

    return 0;
}
