#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

const int N_MAX = 10000;
const int K_MAX = 30;
const ll INF = LLONG_MAX / 2;

int N, K;
int L[N_MAX + 2], R[N_MAX + 2];

int nxt[N_MAX + 2];
int prv[N_MAX + 2];

ll answer;

ll distA[N_MAX + 2];
int fromA[N_MAX + 2];
ll distB[N_MAX + 2];
int fromB[N_MAX + 2];

int f (int i, int j) {
    return abs(R[i] - L[j]);
}

void Bellman () {
    fill(distA + 1, distA + N + 1, INF);
    fill(distB + 1, distB + N + 1, INF);
    queue <pair <int, bool>> q;
    for (int i = 1; i <= N; i++) {
        if (prv[i] != 0) {
            distA[i] = 0;
            fromA[i] = 0;
            q.push({i, 0});
        }
    }
    while (q.empty() == false) {
        int i = q.front().first;
        bool t = q.front().second;
        q.pop();
        if (t == 1) {
            for (int j = i + 1; j <= N; j++) {
                if (nxt[i] != j) {
                    ll d = distB[i] + f(i, j);
                    if (d < distA[j]) {
                        distA[j] = d;
                        fromA[j] = i;
                        q.push({j, 0});
                    }
                }
            }
        } else {
            if (prv[i] != 0) {
                int j = prv[i];
                ll d = distA[i] - f(j, i);
                if (d < distB[j]) {
                    distB[j] = d;
                    fromB[j] = i;
                    q.push({j, 1});
                }
            }
        }
    }
    int i = 0;
    for (int j = 1; j <= N; j++) {
        if (nxt[j] != N + 1 && distB[j] < distB[i]) {
            i = j;
        }
    }
    if (i == 0) {
        return;
    }
    answer += distB[i];
    nxt[i] = N + 1;
    while (i != 0) {
        i = fromB[i];
        int j = fromA[i];
        prv[i] = j;
        nxt[j] = i;
        i = j;
    }
}

int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    cin >> N >> K;
    for (int i = 1; i <= N; i++) {
        cin >> L[i] >> R[i];
    }
    for (int i = 1; i <= N; i++) {
        nxt[i] = i + 1;
        prv[i] = i - 1;
        if (i < N) {
            answer += f(i, i + 1);
        }
    }
    while (--K) {
        Bellman();
    }
    cout << answer << "\n";

    return 0;
}
