#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

const int N_MAX = 10000;
const int K_MAX = 30;
const ll INF = LLONG_MAX / 2;

int N, K;
int L[N_MAX + 2], R[N_MAX + 2];

int nxt[N_MAX + 2];
int prv[N_MAX + 2];

ll answer;

int f (int i, int j) {
    return abs(R[i] - L[j]);
}

ll potA[N_MAX + 2];
ll potB[N_MAX + 2];

void Bellman () {
    queue <pair <int, bool>> q;
    for (int i = 1; i <= N; i++) {
        potA[i] = INF;
        potB[i] = INF;
        if (prv[i] != 0) {
            potA[i] = 0;
            q.push({i, 0});
        }
    }
    while (q.empty() == false) {
        int i = q.front().first;
        bool t = q.front().second;
        q.pop();
        if (t == 1) {
            for (int j = i + 1; j <= N; j++) {
                if (nxt[i] != j) {
                    ll d = potB[i] + f(i, j);
                    if (d < potA[j]) {
                        potA[j] = d;
                        q.push({j, 0});
                    }
                }
            }
        } else {
            if (prv[i] != 0) {
                int j = prv[i];
                ll d = potA[i] - f(j, i);
                if (d < potB[j]) {
                    potB[j] = d;
                    q.push({j, 1});
                }
            }
        }
    }
}

ll distA[N_MAX + 2];
int fromA[N_MAX + 2];
ll distB[N_MAX + 2];
int fromB[N_MAX + 2];

bool seenA[N_MAX + 2];
bool seenB[N_MAX + 2];
void Dijkstra () {
    priority_queue <tuple <ll, int, bool>> q;
    for (int i = 1; i <= N; i++) {
        distA[i] = INF;
        distB[i] = INF;
        seenA[i] = false;
        seenB[i] = false;
        if (prv[i] != 0) {
            distA[i] = 0 - potA[i];
            fromA[i] = 0;
            q.push({-distA[i], i, 0});
        }
    }
    while (q.empty() == false) {
        ll _; int i; bool t;
        tie(_, i, t) = q.top();
        q.pop();
        if (t == 1) {
            if (seenB[i] == true) {
                continue;
            }
            seenB[i] = true;
            for (int j = i + 1; j <= N; j++) {
                if (nxt[i] != j && seenA[j] == false) {
                    ll d = distB[i] + f(i, j) - potA[j] + potB[i];
                    if (d < distA[j]) {
                        distA[j] = d;
                        fromA[j] = i;
                        q.push({-d, j, 0});
                    }
                }
            }
        } else {
            if (seenA[i] == true) {
                continue;
            }
            seenA[i] = true;
            if (prv[i] != 0) {
                int j = prv[i];
                ll d = distA[i] - f(j, i) - potB[j] + potA[i];
                if (d < distB[j]) {
                    distB[j] = d;
                    fromB[j] = i;
                    q.push({-d, j, 1});
                }
            }
        }
    }
    int i = 0;
    for (int j = 1; j <= N; j++) {
        if (nxt[j] != N + 1 && distB[j] + potB[j] < distB[i] + potB[i]) {
            i = j;
        }
    }
    if (i != 0) {
        answer += distB[i] + potB[i];
        nxt[i] = N + 1;
        while (i != 0) {
            i = fromB[i];
            int j = fromA[i];
            prv[i] = j;
            nxt[j] = i;
            i = j;
        }
    }
    for (int i = 1; i <= N; i++) {
        potA[i] = distA[i];
        potB[i] = distB[i];
    }
}

int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    cin >> N >> K;
    for (int i = 1; i <= N; i++) {
        cin >> L[i] >> R[i];
    }
    for (int i = 1; i <= N; i++) {
        nxt[i] = i + 1;
        prv[i] = i - 1;
        if (i < N) {
            answer += f(i, i + 1);
        }
    }
    Bellman();
    while (--K) {
        Dijkstra();
    }
    cout << answer << "\n";

    return 0;
}
