#include <bits/stdc++.h>

using namespace std;

double p;
int n, l, r;

random_device rd;
default_random_engine re(rd());
uniform_int_distribution<int> uniform_dist(1, 1000);

bool correct(vector<int> &a, vector<int> &b, int nc) {
	if (a.size() != nc) return false;
	if (a.size() != b.size()) return false;
	if (a != b) return false;
	
	vector<int> c(n, 0);
	for (int i=0; i<nc; i++) {
		c[a[i]]++;
		if (c[a[i]] > 1) return false;
	}
	
	return true;
}

bool correct2(vector<int> &a) {
	if (a.size() > n) return false;
	
	vector<int> c(n, 0);
	for (int i=0; i<a.size(); i++) {
		c[a[i]]++;
		if (c[a[i]] > 1) return false;
	}
	
	return true;
}

void push(vector<int> &a, vector<int> &b, int chr) {
	// double trg = (double)rand() / (double)RAND_MAX;
	int trg = uniform_dist(re);
	
	// cout << "C: " << chr << "\tT: " << trg << "\tP: " << p << endl;
	
	if (trg < p) {
		// Go the the left string
		a.push_back(chr);
	} else {
		// Go to the right string
		b.push_back(chr);
	}
}

void pop(vector<int> &a, vector<int> &b) {
	// double trg = (double)rand() / (double)RAND_MAX;
	int trg = uniform_dist(re);
	
	// cout << "C: " << "-1" << "\tT: " << trg << "\tP: " << p << endl;
	
	if (trg < p) {
		// Go the the left string
		if (a.size()) a.pop_back();
	} else {
		// Go to the right string
		if (b.size()) b.pop_back();
	}
}

long long calculate() {
	vector<int> a, b;
	a.reserve(n);
	b.reserve(n);
	
	long long steps=0;
	
	for (int i=0; i<l; i++) a.push_back(i);
	for (int i=0; i<r; i++) b.push_back(i);
	
	while (!correct(a, b, n)) {
		if (steps > 500) return -1;
		
		/*cout << "A: ";
		for (int i=0; i<a.size(); i++) cout << a[i] << " ";
		cout << "\nB: ";
		for (int i=0; i<b.size(); i++) cout << b[i] << " ";
		cout << endl << endl;*/
		
		// Strings are correct in first x chars
		// We can try to add the next char (which is x)
		if (a.size() == b.size() && correct(a, b, a.size())) {
			push(a, b, a.size());
			steps++;
			continue;
		}
		
		// First string is invalid (too long or duplicates)
		// Try to remove last char from it
		if (!correct2(a)) {
			pop(a, b);
			steps++;
			continue;
		}
		
		// Second string is invalid (too long or duplicates)
		// Try to remove last char from it
		if (!correct2(b)) {
			pop(a, b);
			steps++;
			continue;
		}
		
		// First string is shorter
		// Try to add next char to it
		if (a.size() < b.size()) {
			push(a, b, a.size());
			steps++;
			continue;
		}
		
		// Second string is shorter
		// Try to add next char to it
		if (a.size() > b.size()) {
			push(a, b, b.size());
			steps++;
			continue;
		}
	}
	
	/*cout << "A: ";
	for (int i=0; i<a.size(); i++) cout << a[i] << " ";
	cout << "\nB: ";
	for (int i=0; i<b.size(); i++) cout << b[i] << " ";
	cout << endl << endl;*/
	
	// cout << "STEPS: " << steps << "\n";
	return steps;
}

int main() {
	cin >> p >> n >> l >> r;
	p *= 1000;
	
	// srand((unsigned)time(NULL));
    
	long long steps = 0;
	int actual = 0;
	
	int attempts = 51000;
	for (int i=0; i<attempts; i++) {
		long long curr = calculate();
		
		if (curr != -1) {
			steps += curr;
			actual++;
		}
	};
	
	cout << setprecision(12) << (double)steps / (double)attempts << endl;
}

