#include <iostream>
#include <vector>
#include <climits>

using namespace std;

int n, k;
vector<pair<int, int>> requests;
vector<int> floors;

vector<vector<long long>> mem;

long long calculate(int i) {
	if (i >= n) {
		return 0;
	}
	
	// cout << "I: " << i << "\n";
	auto [from, to] = requests[i];
	
	long long bestcost = LLONG_MAX;
	
	for (int j=0; j<k; j++) {
		// cout << i << " " << j << endl;
		
		// cout << "Lift " << j << " for request " << i << " needs to go from " << floors[j] << " to " << from << endl;
		// Cost of using j-th lift for i-th request
		long long cost = 0;
		
		// Go from previous floor to current flor empty
		if (floors[j] != -1) cost += abs(floors[j] - from);
		
		// Now we travel to destination floor
		int tmpold = floors[j];
		floors[j] = to;
		
		// cout << "Cost of starting lift " << j << " for request " << i << " is " << cost << endl;
		
		// Go to the next request...
		if (mem[i][j] != -1) cost += mem[i][j];
		else if (i != n-1) cost += calculate(i+1);
		floors[j] = tmpold;
		
		mem[i][j] = cost;
		if (cost < bestcost) bestcost = cost;
	}
	
	// cout << "Best for " << i << " is " << bestlift << endl;
	return bestcost;
}

int main() {
	cin >> n >> k;
	
	requests = vector<pair<int, int>>(n);
	floors = vector<int>(k, -1);
	
	mem = vector<vector<long long>>(n, vector<long long>(k, -1));
	
	for (int i=0; i<n; i++) {
		int li, ri;
		cin >> li >> ri;
		requests[i] = {li, ri};
	}
	
	cout << calculate(0) << endl;
	return 0;
}

